      program gen_cylinder

      implicit none

      integer meshf
      real*8 r, R1, R2, c
      real*8 phi1, phi2, h2, h1
      real*8 a1, a2, cr1, cr2, d1, d2
      integer i,j,k,count
                 
      character*10 inp   

c...  Read data
      call getarg(1,inp); read(inp,*) r
      call getarg(2,inp); read(inp,*) R1
      call getarg(3,inp); read(inp,*) R2
      call getarg(4,inp); read(inp,*) c

c...  Calculate the values
      phi1 = asin(r/R1)
      phi2 = asin(r/R2)
      h2   = R2*(cos(phi2)-1d0)+R1*(1d0-cos(phi1))+c
      h1   = 0d0
      a1  = R1-R1*cos(phi1)
      cr1 = ((2d0+dsqrt(2d0))*(a1**2))/(r**2+a1**2)
      d1  = dsqrt(
     &     ( cr1*(r**2)*(2d0-cr1*(2d0-dsqrt(2d0))) )
     &     /
     &     ( (2d0-dsqrt(2d0))*(1d0-cr1)**2 )  )
      a2  = R2-R2*cos(phi2)
      cr2 = ((2d0+dsqrt(2d0))*(a2**2))/(r**2+a2**2)
      d2  = dsqrt(
     &     ( cr2*(r**2)*(2d0-cr2*(2d0-dsqrt(2d0))) )
     &     /
     &     ( (2d0-dsqrt(2d0))*(1d0-cr2)**2 )  )
c...  Open file
      meshf = 99
      open (meshf, file='cornea.dat', status='unknown')      

!  Write Header
      write (meshf,*) 3 
      write (meshf,*) 2,2,1
      write (meshf,*) 3,3,2
      
!  Knots
      do i = 1,2
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
        write (meshf,"(F13.9)", ADVANCE = "YES") 1.0d0 
      enddo
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
        write (meshf,"(F13.9)", ADVANCE = "YES") 1.0d0 

      
! Controle points 

      !Bottom 
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) d1 + h1
c     &     R1/cos(phi1)-R1*cos(phi1) + h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0-cr1!cos(phi1)
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0



      !Top
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) d2+h2
c     &     R2/cos(phi2)-R2*cos(phi2)+h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0-cr2!cos(phi2)
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

      
! Controle points
      do k = 1,2   
        do j = 1,2
          do i = 1,2
	    count = count + 1
            write(meshf,"(I5)") count		
          enddo
        enddo
      enddo


c...  Write data

      write(meshf,*)r,R1,R2,c
      write(meshf,*)phi1,phi2,h2



      close(meshf)

100   format(F13.9,F13.9,F13.9,F13.9)
      end
