      program gen_mouse

      implicit none

      integer meshf
      real*8 r, Rm, c, h2
      real*8 phim, h1
      real*8 R1, R2, phi1, phi2
      real*8 a1, a2, cr1, cr2, d1, d2
      integer i,j,k,count
                 
      character*10 inp   

c...  Read data
      call getarg(1,inp); read(inp,*) r
      call getarg(2,inp); read(inp,*) Rm
      call getarg(3,inp); read(inp,*) c
      call getarg(4,inp); read(inp,*) h2

c...  Calculate the values
      h1   = 0d0

      phim = asin(r/Rm)
      a1  = Rm-Rm*cos(phim) + h2/2d0 - c/2d0
      cr1 = ((2d0+dsqrt(2d0))*(a1**2))/(r**2+a1**2)
      d1  = dsqrt(
     &     ( cr1*(r**2)*(2d0-cr1*(2d0-dsqrt(2d0))) )
     &     /
     &     ( (2d0-dsqrt(2d0))*(1d0-cr1)**2 )  )

      a2  = a1 + c - (h2-h1)
      cr2 = ((2d0+dsqrt(2d0))*(a2**2))/(r**2+a2**2)
      d2  = dsqrt(
     &     ( cr2*(r**2)*(2d0-cr2*(2d0-dsqrt(2d0))) )
     &     /
     &     ( (2d0-dsqrt(2d0))*(1d0-cr2)**2 )  )
c      d1=-d1
      d2=-d2

      phi1=2d0*atan(a1/r)
      R1=a1/(1d0-cos(phi1))
      phi2=2d0*atan(a2/r)
      R2=a2/(1d0-cos(phi2))
c...  Open file
      meshf = 99
      open (meshf, file='mouse.dat', status='unknown')      

!  Write Header
      write (meshf,*) 3 
      write (meshf,*) 2,2,1
      write (meshf,*) 3,3,2
      
!  Knots
      do i = 1,2
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
        write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
        write (meshf,"(F13.9)", ADVANCE = "YES") 1.0d0 
      enddo
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0.0d0  
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1.0d0 
      write (meshf,"(F13.9)", ADVANCE = "YES") 1.0d0 
      
! Controle points 
      !Bottom 
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) (d1 + h1)
c     &     R1/cos(phi1)-R1*cos(phi1) + h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0-cr1!cos(phi1)
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h1
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

      !Top
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) (d2+h2)
c     &     R2/cos(phi2)-R2*cos(phi2)+h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0-cr2!cos(phi2)
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) -1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") dsqrt(2d0)/2d0
      
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 1d0*r
      write (meshf,"(F13.9)", ADVANCE = "NO" ) 0d0
      write (meshf,"(F13.9)", ADVANCE = "NO" ) h2
      write (meshf,"(F13.9)", ADVANCE = "YES") 1d0

      
! Controle points
      do k = 1,2   
        do j = 1,2
          do i = 1,2
	    count = count + 1
            write(meshf,"(I5)") count		
          enddo
        enddo
      enddo


c...  Write data

      write(meshf,*)r, Rm, c, h2
      write(meshf,*)a1, a2, R1, R2
      write(meshf,*)d1, d2, cr1, cr2 
      write(meshf,*)phi1, phi2



      close(meshf)

100   format(F13.9,F13.9,F13.9,F13.9)
      end
