      real*8, allocatable :: U_KNOT(:), V_KNOT(:),W_KNOT(:)  
      integer NSD,P,Q,R,MCP,NCP,OCP
      integer uproc,vproc,wproc
      integer meshf,knotfile
      integer flg,i,j

      character*10 inp
c
c...  Read in preliminary information
c
      meshf = 11
      open (meshf, file='mesh.dat', status='old')
      read (meshf,*)  NSD           ! number of spatial dimensions
      read (meshf,*)  P, Q, R       ! degree of curves in u, v, and w direction
      read (meshf,*)  MCP, NCP, OCP ! number of control points in each direction

c
c...  Allocate arrays for knot vectors 
c
      allocate(U_KNOT(MCP+P+1))    
      allocate(V_KNOT(NCP+Q+1))
      allocate(W_KNOT(OCP+R+1))

c
c...  Read knot vectors and control net
c
      do i = 1,MCP+P+1
         if (i < MCP+P+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO")  U_KNOT(i) ! read U_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") U_KNOT(i) 
         endif
      enddo

      do i = 1,NCP+Q+1
         if (i < NCP+Q+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO")  V_KNOT(i) ! read V_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") V_KNOT(i) 
         endif
      enddo

      do i = 1,OCP+R+1
         if (i < OCP+R+1) then
            read (meshf,"(F13.9)", ADVANCE = "NO")  W_KNOT(i) ! read W_KNOT
         else
            read (meshf,"(F13.9)", ADVANCE = "YES") W_KNOT(i) 
         endif
      enddo

c
c...  Get number of procs
c
      !!call 
      i = iargc()
      if (i.eq.3) then  
        call getarg(1,inp); read(inp,*) uproc
        call getarg(2,inp); read(inp,*) vproc
        call getarg(3,inp); read(inp,*) wproc
      else
        write(*,*)"Procs in u direction? "
        read(*,*) uproc
        write(*,*)"Procs in v direction? " 
        read(*,*) vproc
        write(*,*)"Procs in w direction? "
        read(*,*) wproc
      endif       
c
c...  Partition in U
c      
      if (uproc .gt. 1) then      
        knotfile = 12	
        open  (knotfile, file='upart.dat', status='unknown')      
	
	write (knotfile,"(I6)", ADVANCE = "NO" ) 1  
	write (knotfile,"(I6)", ADVANCE = "NO" ) 0 
	write (knotfile,"(I6)", ADVANCE = "YES") 0  
	
	write (knotfile,"(I6)", ADVANCE = "NO" ) uproc-1  
	write (knotfile,"(I6)", ADVANCE = "NO" ) 0 
	write (knotfile,"(I6)", ADVANCE = "YES") 0  
	
	write (knotfile,"(I6)", ADVANCE = "YES") 0
		
        do i = 1,uproc-1
	  j = 1 + P + i*((MCP-P)/uproc)
          if (i < uproc) then
            write (knotfile,"(F13.9)", ADVANCE = "NO")  U_KNOT(j) 
          else
            write (knotfile,"(F13.9)", ADVANCE = "YES") U_KNOT(j)  
          endif
        enddo    
        close(knotfile)
      endif	      
c
c...  Partition in V
c      
      if (vproc .gt. 1) then      
        knotfile = 13	
        open  (knotfile, file='vpart.dat', status='unknown')      
	
	write (knotfile,"(I6)", ADVANCE = "NO" ) 0  
	write (knotfile,"(I6)", ADVANCE = "NO" ) 1 
	write (knotfile,"(I6)", ADVANCE = "YES") 0  
	
	write (knotfile,"(I6)", ADVANCE = "NO" ) 0 
	write (knotfile,"(I6)", ADVANCE = "NO" ) vproc-1 
	write (knotfile,"(I6)", ADVANCE = "YES") 0  
	
	write (knotfile,"(I6)", ADVANCE = "YES") 0
		
        do i = 1,vproc-1
	  j =  1 + Q + i*((NCP-Q)/vproc)
          if (i < vproc) then
            write (knotfile,"(F13.9)", ADVANCE = "NO")  V_KNOT(j) 
          else
            write (knotfile,"(F13.9)", ADVANCE = "YES") V_KNOT(j)  
          endif
        enddo    
        close(knotfile)
      endif      
c
c...  Partition in W
c      
      if (wproc .gt. 1) then      
        knotfile = 14	
        open  (knotfile, file='wpart.dat', status='unknown')      
	
	write (knotfile,"(I6)", ADVANCE = "NO" ) 0  
	write (knotfile,"(I6)", ADVANCE = "NO" ) 0 
	write (knotfile,"(I6)", ADVANCE = "YES") 1  
	
	write (knotfile,"(I6)", ADVANCE = "NO" ) 0  
	write (knotfile,"(I6)", ADVANCE = "NO" ) 0 
	write (knotfile,"(I6)", ADVANCE = "YES") wproc-1  
	
	write (knotfile,"(I6)", ADVANCE = "YES") 0
		
        do i = 1,wproc-1
	  j =  1 + R + i*((OCP-Q)/wproc)
          if (i < wproc) then
            write (knotfile,"(F13.9)", ADVANCE = "NO")  W_KNOT(j) 
          else
            write (knotfile,"(F13.9)", ADVANCE = "YES") W_KNOT(j)  
          endif
        enddo    
        close(knotfile)
      endif

      end
