c     This routine links each element in the h-refined mesh with its
c        parent element in the unrefined mesh.
c
c     EL_CON(i) = j implies that element j of the OLD mesh is the parent
c           of element i in the new mesh.      
c     
c       Feb. 10, 2004
c       J. Austin Cottrell
c       CAM Graduate Student
c       Institute for Computational Engineering Science
c       The University of Texas at Austin

      subroutine gen_EL_CON_3D(EL_CON,new_NEL,new_MCP,new_NCP,
     &     new_OCP,uflag,vflag,wflag)

      use aAdjKeep
      include "common.h"

      integer e,new_NEL,i,j,k,icount,jcount,new_MCP,new_NCP
      integer  EL_CON(new_NEL), new_OCP,kcount,uflag,vflag,wflag
      

      
c     uflag = 1 denotes that we are refining in the u direction. That is
c        we are inserting knots into U_KNOT. Likewise for vflag and wflag      
      
      EL_CON = 0
      e = 0
      kcount = 0
      do k = 1,OCP-R
         jcount = 0
         do j = 1,NCP-Q
            icount = 0
            e = (MCP-P)*(NCP-Q)*(k-1)+(MCP-P)*(j-1)
            do i = 1,MCP-P
               e = e+1
               EL_CON(i+icount+(j-1+jcount)*(new_MCP-P)+
     &              (k-1+kcount)*(new_MCP-P)*(new_NCP-Q)) = e

               
               ! check to see if the element has been split in u
               if ((U_KNOT(i+P).ne.U_KNOT(i+P+1)).and.(uflag.eq.1)) then
                  icount = icount + 1
                  EL_CON(i+icount+(j-1+jcount)*(new_MCP-P)+
     &              (k-1+kcount)*(new_MCP-P)*(new_NCP-Q)) = e
               endif
            enddo

            ! check to see if the element has been split in v
            if ((V_KNOT(j+Q).ne.V_KNOT(j+Q+1)).and.(vflag.eq.1)) then
               icount = 0
               jcount = jcount+1
               e = (MCP-P)*(NCP-Q)*(k-1)+
     &              (j-1)*(MCP-P)
               do i = 1,MCP-P
                  e = e+1
                  EL_CON(i+icount+(j-1+jcount)*(new_MCP-P)+
     &                 (k-1+kcount)*(new_MCP-P)*(new_NCP-Q)) = e
                  if ((U_KNOT(i+P).ne.U_KNOT(i+P+1)).and.(uflag.eq.1))
     &              then
                     icount = icount + 1
                     EL_CON(i+icount+(j-1+jcount)*(new_MCP-P)+
     &                    (k-1+kcount)*(new_MCP-P)*(new_NCP-Q)) = e
                  endif
               enddo
            endif
         enddo

         ! check to see if the element has been split in w
         if ((W_KNOT(k+R).ne.W_KNOT(k+R+1)).and.(wflag.eq.1)) then
            kcount = kcount+1
            jcount = 0
            do j = 1,NCP-Q
               icount = 0
               e = (MCP-P)*(NCP-Q)*(k-1)+(MCP-P)*(j-1)
               do i = 1,MCP-P
                  e = e+1
                  EL_CON(i+icount+(j-1+jcount)*(new_MCP-P)+
     &                 (k-1+kcount)*(new_MCP-P)*(new_NCP-Q)) = e
                  if ((U_KNOT(i+P).ne.U_KNOT(i+P+1)).and.(uflag.eq.1))
     &              then
                     icount = icount + 1
                     EL_CON(i+icount+(j-1+jcount)*(new_MCP-P)+
     &                    (k-1+kcount)*(new_MCP-P)*(new_NCP-Q)) = e
                  endif
               enddo
               if ((V_KNOT(j+Q).ne.V_KNOT(j+Q+1)).and.(vflag.eq.1)) then
                  icount = 0
                  jcount = jcount+1
                  e = (MCP-P)*(NCP-Q)*(k-1)+
     &                 (j-1)*(MCP-P)
                  do i = 1,MCP-P
                     e = e+1
                     EL_CON(i+icount+(j-1+jcount)*(new_MCP-P)+
     &                    (k-1+kcount)*(new_MCP-P)*(new_NCP-Q)) = e
                     if ((U_KNOT(i+P).ne.U_KNOT(i+P+1)).and.
     &                 (uflag.eq.1)) then
                        icount = icount + 1
                        EL_CON(i+icount+(j-1+jcount)*(new_MCP-P)+
     &                       (k-1+kcount)*(new_MCP-P)*(new_NCP-Q)) = e
                     endif
                  enddo
               endif
            enddo
         endif
      enddo

         
      return
      end
