c     This routine generates the new element data by inheritance from the
c        parent element. EL_CON contains the geneology information. See
c        gen_EL_CON_3D.f for details.
c
c       Feb. 10, 2004
c       J. Austin Cottrell
c       CAM Graduate Student
c       Institute for Computational Engineering Science
c       The University of Texas at Austin

      subroutine gen_EL_DATA_3D_p(new_NEL,EL_CON,
     &     new_LD_EL, new_EY, new_NU)

      use aAdjKeep

      include "common.h"

      

      integer new_NEL, e
      integer EL_CON(new_NEL)
      real*8 new_LD_EL(new_NEL,NSD), new_EY(new_NEL), new_NU(new_NEL)





      new_LD_EL = 0d+0
      new_EY = 0d+0
      new_NU = 0d+0



c...  Loop over elements

      do e = 1, new_NEL
         
         
c
c...  set Face Load
c

         new_LD_EL(e,1) = LD_EL(EL_CON(e),1)
         new_LD_EL(e,2) = LD_EL(EL_CON(e),2)
         new_LD_EL(e,3) = LD_EL(EL_CON(e),3)

c
c...  set Youngs modulus
c     
         new_EY(e) = EY(EL_CON(e))

c
c...  set Poisson's ratio
c
         new_NU(e) = NU(EL_CON(e))

      enddo

      return
      end
