
      

      use aAdjKeep
      include "common.h"

      
!     
!     p-refinement for the 3D code.
!
!     May 1-2, 2004
!     J. Austin Cottrell
!     CES Graduate Student
!     Institute for Computational Engineering and Sciences
!     The University of Texas at Austin
!      

c     -------------------------------------------------------
      integer i,dist_knots_u,dist_knots_v,tu,dir_u,new_MCP,new_NCP,
     &     direction,new_P,new_Q,new_R,new_NNODZ,new_NEL,
     &     new_NFACE,dir_v,dir_w,dist_knots_w,new_OCP,tv,tw,
     &     u_flag,v_flag,w_flag

      
      real*8, allocatable :: Qw(:,:,:,:), new_U_KNOT(:),new_V_KNOT(:),
     &     new_BW(:,:,:,:),Vh(:),new_B_NET(:,:,:,:),new_EY(:),new_NU(:),
     &     new_LD_FACE(:,:),new_LD_EL(:,:),new_DIR_BC(:,:),
     &     new_W_KNOT(:),temp_BW(:,:,:,:),temp_BW2(:,:,:,:)

      
      integer, allocatable ::  FACE_CON(:),new_FACE_OR(:),EL_CON(:),
     &     new_INN(:,:),new_IEN(:,:),new_FACE_IEN(:,:),new_IBC(:,:),
     &     new_IBC_FACE(:,:),new_IPER(:)

      character*10 inp

    
c...  Get initial mesh data
      call input_3D

c...  Form projective control net
      BW = B_NET
      do i = 1,NSD
         BW(:,:,:,i) = BW(:,:,:,i)*B_NET(:,:,:,NSD+1)
      enddo

      tu = 0
      tv = 0
      tw = 0

    
 
      
c...  Check for command line input
      !!call IArgC(i)
      i = iargc()
      write(*,*) i
      if (i.eq.3) then 
        call getarg(1,inp); read(inp,*) new_P
        call getarg(2,inp); read(inp,*) new_Q
        call getarg(3,inp); read(inp,*) new_R	
	
	tu = new_P - P
	tv = new_Q - Q
	tw = new_R - R
	
	if ((tu.lt.0).or.(tv.lt.0).or.(tw.lt.0)) then
	  write(*,*) tu, tv, tw
	  write(*,*) "Requested order lower then original"
	  call abort
	else if ((tu.eq.0).and.(tv.eq.0).and.(tw.eq.0)) then
	  write(*,*) tu, tv, tw
	  write(*,*) "No order elevation required"
	  stop		
	else if ((tu.gt.0).and.(tv.gt.0).and.(tw.gt.0)) then
	  direction = 7
	else if ((tu.gt.0).and.(tv.gt.0)) then  
	  direction = 4	
	else if ((tu.gt.0).and.(tw.gt.0)) then
	  direction = 5	
	else if ((tv.gt.0).and.(tw.gt.0)) then
	  direction = 6	
	else if (tu.gt.0) then  
	  direction = 1	
	else if (tv.gt.0) then
	  direction = 2	
	else if (tw.gt.0) then  
	  direction = 3	   
	else
	  direction = 0  
	endif	
	
	
      else
c... Allow the user to specify elevation direction
        write(*,*)"Enter direction in which to degree elevate"
        write(*,*)" (1 - u direction, 2 - v direction, 3 - w-direction,"
        write(*,*)" 4 - u & v, 5 - u & w, 6 - v & w,"
        write(*,*)" 7 - all directions):"
        read(*,*) direction
	
        if ((direction.eq.1).or.
     &      (direction.eq.4).or.(direction.eq.5).or.
     &      (direction.eq.7)) then
          write(*,*)"Enter desired degree in u direction:"
          read(*,*) new_P
	endif  
	
        if ((direction.eq.2).or.
     &      (direction.eq.4).or.(direction.eq.6).or.
     &      (direction.eq.7)) then	
          write(*,*)"Enter desired degree in v direction:"
          read(*,*) new_Q 
	endif  	
	
        if ((direction.eq.3).or.
     &      (direction.eq.5).or.(direction.eq.6).or.
     &      (direction.eq.7)) then	  
          write(*,*)"Enter desired degree in w direction:"
          read(*,*) new_R 
	endif  

	tu = new_P - P
	tv = new_Q - Q
	tw = new_R - R
	
	if ((tu.lt.0).or.(tv.lt.0).or.(tw.lt.0)) then
	  write(*,*) tu, tv, tw
	  write(*,*) "Requested order lower then original"
	  call abort
	endif

		   	  	
      endif


c...  Calculate number of distinct knots in u
      dist_knots_u = 1
      do i = 1,MCP-P
        if (U_KNOT(P+i).ne.U_KNOT(P+i+1)) then
          dist_knots_u = dist_knots_u + 1
        endif
      enddo
     
c...  Calculate number of distinct knots in v
      dist_knots_v = 1
      do i = 1,NCP-Q
        if (V_KNOT(Q+i).ne.V_KNOT(Q+i+1)) then
          dist_knots_v = dist_knots_v + 1
        endif
      enddo

c...  Calculate number of distinct knots in w
      dist_knots_w = 1
      do i = 1,OCP-R
        if (W_KNOT(R+i).ne.W_KNOT(R+i+1)) then
          dist_knots_w = dist_knots_w + 1
        endif
      enddo         

   

c
c...  ALL U DIRECTION ELEVATIONS
c
      if ((direction.eq.1).or.(direction.eq.4).or.(direction.eq.5).or.
     &  (direction.eq.7)) then

        if (direction.eq.1) then
	
c.....    Elevate in U ONLY                  
          
          allocate(new_U_KNOT(MCP+P+1+dist_knots_u*tu))
          allocate(new_BW(MCP+(dist_knots_u-1)*tu,NCP,OCP,NSD+1))
          allocate(new_V_KNOT(NCP+Q+1))
          allocate(new_W_KNOT(OCP+R+1))

          dir_u = 1             ! elevate in u alone
          dir_v = 0
          dir_w = 0   
                 
          call degree_elevate_solid(MCP,P,U_KNOT,NCP,Q,V_KNOT,
     &      OCP,R,W_KNOT,BW,tu,dir_u,dir_v,dir_w,dist_knots_u,new_BW,
     &      new_MCP,new_U_KNOT,NEW_P,new_NCP,new_V_KNOT,new_Q,new_OCP,
     &      new_W_KNOT,new_R)

        
        elseif (direction.eq.4) then
          
c.....    Elevate in U and V
       
          dir_u = 1             ! this will change, but we elevate
          dir_v = 0             !  in only one direction at a time,
          dir_w = 0             !  starting with u.
          
          allocate(new_U_KNOT(MCP+P+1+dist_knots_u*tu))
          allocate(new_V_KNOT(NCP+Q+1+dist_knots_v*tv))
          allocate(new_BW(MCP+(dist_knots_u-1)*tu,
     &      NCP+(dist_knots_v-1)*tv,OCP,NSD+1))
          allocate(new_W_KNOT(OCP+R+1))
          
          allocate(temp_BW(MCP+(dist_knots_u-1)*tu,NCP,OCP,NSD+1))
          
          call degree_elevate_solid(MCP,P,U_KNOT,NCP,Q,V_KNOT,
     &      OCP,R,W_KNOT,BW,tu,dir_u,dir_v,dir_w,dist_knots_u,temp_BW,
     &      new_MCP,new_U_KNOT,NEW_P,NCP,V_KNOT,Q,new_OCP,
     &      new_W_KNOT,new_R)
          
          dir_u = 0
          dir_v = 1             ! now we elevate in v the solid
          dir_w = 0             !  which was just elevated in u
          
          call degree_elevate_solid(new_MCP,new_P,new_U_KNOT,NCP,
     &      Q,V_KNOT,OCP,R,W_KNOT,temp_BW,tv,dir_u,dir_v,dir_w,
     &      dist_knots_v,new_BW,new_MCP,new_U_KNOT,NEW_P,
     &      new_NCP,new_V_KNOT,new_Q,new_OCP,new_W_KNOT,new_R)



        elseif (direction.eq.5) then
          
c.....    Elevate in U and W
          
          dir_u = 1             ! this will change, but we elevate
          dir_v = 0             !  in only one direction at a time,
          dir_w = 0             !  starting with u.
          
          allocate(new_U_KNOT(MCP+P+1+dist_knots_u*tu))
          allocate(new_V_KNOT(NCP+Q+1))
          allocate(new_W_KNOT(OCP+R+1+dist_knots_w*tw))
          allocate(new_BW(MCP+(dist_knots_u-1)*tu,
     &      NCP,OCP+(dist_knots_w-1)*tw,NSD+1))

          
          allocate(temp_BW(MCP+(dist_knots_u-1)*tu,NCP,OCP,NSD+1))

          
          call degree_elevate_solid(MCP,P,U_KNOT,NCP,Q,V_KNOT,
     &      OCP,R,W_KNOT,BW,tu,dir_u,dir_v,dir_w,dist_knots_u,temp_BW,
     &      new_MCP,new_U_KNOT,NEW_P,new_NCP,new_V_KNOT,new_Q,OCP,
     &      W_KNOT,R)
          
          dir_u = 0
          dir_v = 0             ! now we elevate in w the solid
          dir_w = 1             !  which was just elevated in u
          
          call degree_elevate_solid(new_MCP,new_P,new_U_KNOT,NCP,
     &      Q,V_KNOT,OCP,R,W_KNOT,temp_BW,tw,dir_u,dir_v,dir_w,
     &      dist_knots_w,new_BW,new_MCP,new_U_KNOT,NEW_P,
     &      new_NCP,new_V_KNOT,new_Q,new_OCP,new_W_KNOT,new_R)          

            
        else

c.....    Elevate in U, V, and W

          allocate(new_U_KNOT(MCP+P+1+dist_knots_u*tu))
          allocate(new_V_KNOT(NCP+Q+1+dist_knots_v*tv))
          allocate(new_W_KNOT(OCP+R+1+dist_knots_w*tw))
          allocate(new_BW(MCP+(dist_knots_u-1)*tu,
     &      NCP+(dist_knots_v-1)*tv,OCP+(dist_knots_w-1)*tw,NSD+1))
      
          
          allocate(temp_BW(MCP+(dist_knots_u-1)*tu,NCP,OCP,NSD+1))
          allocate(temp_BW2(MCP+(dist_knots_u-1)*tu,
     &      NCP+(dist_knots_v-1)*tv,OCP,NSD+1))

          dir_u = 1             ! this will change, but we elevate
          dir_v = 0             !  in only one direction at a time,
          dir_w = 0             !  starting with u.
          
          call degree_elevate_solid(MCP,P,U_KNOT,NCP,Q,V_KNOT,
     &      OCP,R,W_KNOT,BW,tu,dir_u,dir_v,dir_w,dist_knots_u,temp_BW,
     &      new_MCP,new_U_KNOT,NEW_P,NCP,V_KNOT,Q,OCP,
     &      W_KNOT,R)

          dir_u = 0
          dir_v = 1             ! now we elevate in v the solid
          dir_w = 0             !  which was just elevated in u

          call degree_elevate_solid(new_MCP,new_P,new_U_KNOT,NCP,
     &      Q,V_KNOT,OCP,R,W_KNOT,temp_BW,tv,dir_u,dir_v,dir_w,
     &      dist_knots_v,temp_BW2,new_MCP,new_U_KNOT,NEW_P,
     &      new_NCP,new_V_KNOT,new_Q,OCP,W_KNOT,R)

          dir_u = 0             ! finally, we elevate in w
          dir_v = 0             !  the solid which was just
          dir_w = 1             !  elevated in u and v

          call degree_elevate_solid(new_MCP,new_P,new_U_KNOT,new_NCP,
     &      new_Q,new_V_KNOT,OCP,R,W_KNOT,temp_BW2,tw,dir_u,dir_v,dir_w,
     &      dist_knots_w,new_BW,new_MCP,new_U_KNOT,NEW_P,
     &      new_NCP,new_V_KNOT,new_Q,new_OCP,new_W_KNOT,new_R)
          
          
        endif
      endif



c
c... V DIRECTION ELEVATION without U ELEVATION
c

      if ((direction.eq.2).or.(direction.eq.6)) then
        
        if (direction.eq.2) then
          
          dir_u = 0            
          dir_v = 1             ! elevate in v only
          dir_w = 0             
          
          allocate(new_U_KNOT(MCP+P+1))
          allocate(new_V_KNOT(NCP+Q+1+dist_knots_v*tv))
          allocate(new_W_KNOT(OCP+R+1))
          allocate(new_BW(MCP,NCP+(dist_knots_v-1)*tv,OCP,NSD+1))
          
          call degree_elevate_solid(MCP,P,U_KNOT,NCP,Q,V_KNOT,
     &      OCP,R,W_KNOT,BW,tv,dir_u,dir_v,dir_w,dist_knots_v,new_BW,
     &      new_MCP,new_U_KNOT,NEW_P,new_NCP,new_V_KNOT,new_Q,new_OCP,
     &      new_W_KNOT,new_R)   
       
        else

c...      Elevate in V and W

          allocate(new_U_KNOT(MCP+P+1))
          allocate(new_V_KNOT(NCP+Q+1+dist_knots_v*tv))
          allocate(new_W_KNOT(OCP+R+1+dist_knots_w*tw))      
          allocate(new_BW(MCP,NCP+(dist_knots_v-1)*tv,
     &      OCP+(dist_knots_w-1)*tw,NSD+1))
          
          allocate(temp_BW(MCP,NCP+(dist_knots_v-1)*tv,OCP,NSD+1))

          dir_u = 0
          dir_v = 1             ! Begin with first elevating in v
          dir_w = 0             
          
          call degree_elevate_solid(MCP,P,U_KNOT,NCP,Q,V_KNOT,
     &      OCP,R,W_KNOT,BW,tv,dir_u,dir_v,dir_w,dist_knots_v,temp_BW,
     &      new_MCP,new_U_KNOT,NEW_P,new_NCP,new_V_KNOT,new_Q,
     &      OCP,W_KNOT,R)

         
          
          dir_u = 0
          dir_v = 0             ! now we elevate in w the solid
          dir_w = 1             !  which was just elevated in v
          
          call degree_elevate_solid(new_MCP,new_P,new_U_KNOT,new_NCP,
     &      new_Q,new_V_KNOT,OCP,R,W_KNOT,temp_BW,tw,dir_u,dir_v,dir_w,
     &      dist_knots_w,new_BW,new_MCP,new_U_KNOT,NEW_P,
     &      new_NCP,new_V_KNOT,new_Q,new_OCP,new_W_KNOT,new_R)

        
          
        endif
      endif

      


      
c...  W DIRECTION ELEVATION ONLY


      if (direction.eq.3) then

        allocate(new_U_KNOT(MCP+P+1))
        allocate(new_V_KNOT(NCP+Q+1))
        allocate(new_W_KNOT((OCP+R+1)+dist_knots_w*tw))      
        allocate(new_BW(MCP,NCP,OCP+(dist_knots_w-1)*tw,NSD+1))
        
        dir_u = 0
        dir_v = 0               
        dir_w = 1               ! elevate in w alone         


        call degree_elevate_solid(MCP,P,U_KNOT,NCP,Q,V_KNOT,
     &    OCP,R,W_KNOT,BW,tw,dir_u,dir_v,dir_w,dist_knots_w,new_BW,
     &    new_MCP,new_U_KNOT,NEW_P,new_NCP,new_V_KNOT,new_Q,new_OCP,
     &    new_W_KNOT,new_R)   

        
      endif

c...  NO ELEVATION 


      if (direction.eq.0) then

        allocate(new_U_KNOT(MCP+P+1))
        allocate(new_V_KNOT(NCP+Q+1))
        allocate(new_W_KNOT(OCP+R+1))      
        allocate(new_BW(MCP,NCP,OCP,NSD+1))
        
        new_U_KNOT = U_KNOT
        new_V_KNOT = V_KNOT
        new_W_KNOT = W_KNOT
        new_BW     = BW
    
      endif



c ...................................................................
        
         

    

      
c...  Convert projective coordinates into physical coordinates
      allocate(new_B_NET(new_MCP,new_NCP,new_OCP,NSD+1))
      new_B_NET = new_BW
      do i = 1,NSD
         new_B_NET(:,:,:,i) = new_B_NET(:,:,:,i)/new_B_NET(:,:,:,NSD+1)
      enddo



c
c     At this point we have a new control net and new knot vectors in each
c       direction. We must now create connectivities such that we may
c       transfer load and boundary conditions, periodicities, etc. from the
c       original mesh to the new one


      new_NNODZ = new_MCP*new_NCP*new_OCP
      new_NEL = (new_MCP-new_P)*(new_NCP-new_Q)*(new_OCP-new_R)
      new_NFACE = 2*(new_MCP-new_P)*(new_NCP-new_Q)*(1-CLOSED_W_flag) +
     &  2*(new_NCP-new_Q)*(new_OCP-new_R)*(1-CLOSED_U_flag) +
     &  2*(new_MCP-new_P)*(new_OCP-new_R)*(1-CLOSED_V_flag) 



c     We need the connectivities from our original mesh in order to 
c      assign old data to the correct locations in the new mesh.
      call genIEN_INN_3D
      call gen_FACE_IEN_3D


      


c     Identify old faces with new faces to assign boundary conditions
c     FACE_CON(new_el_num) equals the old edge number.
      allocate(FACE_CON(new_NFACE))
      allocate(new_FACE_OR(new_NFACE))
      call gen_FACE_CON_3D_p(FACE_CON,new_NFACE,new_MCP,new_NCP,new_OCP,
     &  new_P,new_Q,new_R,tu,tv,tw)


      
      
c     Generate EL_CON matrix connecting old elements to new ones. 
c      EL_CON(new_el_num) equals the old element number

      allocate(EL_CON(new_NEL))
      call gen_EL_CON_3D_p(EL_CON, new_NEL, new_MCP, new_NCP,new_OCP,
     &  new_P,new_Q,new_R,tu,tv,tw)



      
c...  Create new IEN and INN arrays
	allocate(new_INN(new_MCP*new_NCP*new_OCP,3))
	allocate(new_IEN((new_MCP-new_P)*(new_NCP-new_Q)*(new_OCP-new_R),
     &       (new_P+1)*(new_Q+1)*(new_R+1)))
        call gen_new_IEN_INN_3D_p(new_MCP,new_NCP,new_OCP,new_IEN,
     &       new_INN,new_NEL,new_NNODZ,new_P,new_Q,new_R)



        

        
c...  Also create new boundary connectivity arrays
	allocate(new_FACE_IEN(new_NFACE,(new_P+1)*(new_Q+1)*(new_R+1)))
        call gen_new_FACE_IEN_3D_p(new_NFACE, new_NNODZ,
     &       new_FACE_IEN, new_FACE_OR,new_NEL,new_P,new_Q,new_R,
     &       new_MCP, new_NCP,new_OCP,new_IEN)


        

c
c...  Create new IBC array assign edge data
c
      allocate(new_IBC(new_NNODZ,NSD))
      allocate(new_IBC_FACE(new_NFACE,NSD))
      allocate(new_IPER(new_NNODZ))
      allocate(new_LD_FACE(new_NFACE,NSD))
      allocate(new_DIR_BC(new_NNODZ,NSD))
      call gen_FACE_DATA_3D_p(new_NNODZ,new_NFACE,FACE_CON,
     &  new_FACE_OR,new_P,new_Q,new_R, 
     &  new_FACE_IEN, new_IPER,  new_IBC, new_IBC_FACE, new_LD_FACE,
     &  new_MCP, new_NCP, new_OCP, new_INN, new_B_NET,new_U_KNOT,
     &  new_V_KNOT,new_W_KNOT,new_DIR_BC)

c
c...  Assign element data
c
      allocate(new_LD_EL(new_NEL,NSD))
      allocate(new_EY(new_NEL))
      allocate(new_NU(new_NEL))
      call gen_EL_DATA_3D_p(new_NEL, EL_CON, new_LD_EL, 
     &     new_EY, new_NU)

      
c     ------------------------------------------------------------------

      NNODZ = new_NNODZ
      MCP  = new_MCP
      NCP = new_NCP
      OCP = new_OCP
      P = new_P
      Q = new_Q
      R = new_R
      NFACE = new_NFACE
      NEL = new_NEL     

c...  Write to file refined_mesh.dat
      call output_3D_2(new_U_KNOT,new_V_KNOT,new_W_KNOT,new_B_NET,
     &     new_IPER,new_IBC,new_DIR_BC,new_IBC_FACE,new_LD_FACE,
     &     new_LD_EL,new_EY,new_NU)
     
      stop
      end
