
      subroutine genSparStruc_3D (colm, rowp, icnt)

 
      use aAdjKeep

      include "common.h"

      integer tmpr(NNODZ) , colm(NNODZ+1),
     &  rowp(NNODZ*8*(P+1)*(Q+1)*(R+1))
      integer adjcnt(NNODZ),  mloc(1)
      integer i, j, k, imin, icnt, ibig, ncol 

      integer, allocatable :: row_fill_list(:,:)

      allocate(row_fill_list(NNODZ,8*(P+1)*(Q+1)*(R+1)))

      row_fill_list = 0 

      adjcnt = 0

c.... compute sparse matrix data structures
c     
      call Asadj (row_fill_list,  adjcnt)

c     build the colm array
c     
      colm(1)=1
     
      do i=1,NNODZ
         colm(i+1)=colm(i)+adjcnt(i)
      enddo

c     sort the rowp into increasing order
c     
      ibig=10*NNODZ
      icnt=0
      do i=1,NNODZ
         ncol=adjcnt(i)
         tmpr(1:ncol)=row_fill_list(i,1:ncol)
         do j=1,ncol
            icnt=icnt+1
            imin=minval(tmpr(1:ncol))
            mloc=minloc(tmpr(1:ncol))
            rowp(icnt)=imin
            tmpr(mloc(1))=ibig
         enddo
      enddo

      deallocate(row_fill_list)
      
      return
      end



      subroutine Asadj(row_fill_list, adjcnt)

      use aAdjKeep

      include "common.h"

      integer row_fill_list(NNODZ,8*(P+1)*(Q+1)*(R+1)),k, i, j,
     &  l, ibroke, knd,
     &  adjcnt(NNODZ), ndlist((P+1)*(Q+1)*(R+1)),
     &  nshl, jnd, jlngth, ni, nj, nk


      do i=1, NEL
        
        
c...    Check to see if current element has nonzero area
        ni = INN(IEN(i,1),1)    ! get NURB coordinates
        nj = INN(IEN(i,1),2)
        nk = INN(IEN(i,1),3)
        
        if ((U_KNOT(ni).ne.U_KNOT(ni+1)).and.
     &    (V_KNOT(nj).ne.V_KNOT(nj+1)).and.
     &    (W_KNOT(nk).ne.W_KNOT(nk+1))) then

          if(mod(i,30).eq.0) write(*,*) i
          if(mod(i+1,30).eq.0) write(*,*) i
          if(mod(i+2,30).eq.0) write(*,*) i
          if(mod(i+3,30).eq.0) write(*,*) i
          if(mod(i+4,30).eq.0) write(*,*) i
          if(mod(i+5,30).eq.0) write(*,*) i
          
          nshl = (P+1)*(Q+1)*(R+1)
          
          do j=1,nshl
            ndlist(j)=IEN(i,j)  ! gen list of global "nodes" for this element
          enddo
          do j=1,nshl
            jnd=ndlist(j)       ! jnd is the global "node" we are working on
            jlngth=adjcnt(jnd)  ! current length of j's list
            do k=1,nshl 
              knd=ndlist(k)
              ibroke=0
              
              do l= 1,jlngth    ! row_fill_list is, for each node, the
                                ! list of nodes that I have already
                                ! detected interaction with
                if(row_fill_list(jnd,l).eq. knd) then
                  ibroke=1
                  exit
                endif
              enddo
              
c             
c             to get here k was not in  j's list so add it
c             
              if(ibroke.eq.0) then
                jlngth=jlngth+1 ! lengthen list
                
                if(jlngth.gt.8*nshl) then
                  write(*,*) 'increase overflow factor in genadj'
                  stop
                endif
                
                row_fill_list(jnd,jlngth)=knd ! add unique entry to list
              endif
            enddo               ! finished checking all the k's for this j
            adjcnt(jnd)=jlngth  ! update the counter
          enddo                 ! done with j's
          
        endif
        
      enddo                     ! done with elements in this block
      
      
      
      
      
      return
      end
