      
      subroutine VizGMV_3D(iproc, numprocs, 
     &     istep, fstep,
     &     ini, fin, number, list)
      
      
      use aAdjKeep
      use common
      use mpi

      implicit none
      
c...  Global variables
      integer iproc,numprocs,
     &     istep,fstep,inter,
     &     ini, fin, number,list(1,number)
c...  Local variables
      !General
      integer i, j, k
      !Get values
      integer igauss, jgauss, kgauss, iel, idof, icount, Pcount
      integer ni, nj, nk
      real*8 
     &     nurbcoord(3), std1, std2, std3, da
      real*8
     &     shg(NSHL), shgrad(NSHL,NSD),
     &     ul (NSHL,NDOF), xl (NSHL,NSD),
     &     ui(NDOF), xi(NSD)
      !write
      integer ivtu, ftec, isd
      character*100 hname
      character*30 fname
      character*10 cname
      character*10 bname

c...  Get spatial coordinates and values
      do igauss = 1, NPTSu+1
         do jgauss = 1, NPTSv+1
            do kgauss = 1, NPTSw+1
               nurbcoord(1) = PTSu(igauss)
               nurbcoord(2) = PTSv(jgauss)
               nurbcoord(3) = PTSw(kgauss)
c               if (myid.eq.mpi_master) then
c                   write(*,*) nurbcoord(:), "\n"
c               endif
               do iel = 1, NEL
               !Check to see if current element has nonzero area
                  ni = INN(IEN(iel,1),1) ! get NURB coordinates
                  nj = INN(IEN(iel,1),2)
                  nk = INN(IEN(iel,1),3)
                  std1 = (nurbcoord(1)-U_KNOT(ni))*
     &                 (  nurbcoord(1)-U_KNOT(ni+1))
                  std2 = (nurbcoord(2)-V_KNOT(nj))*
     &                 (  nurbcoord(2)-V_KNOT(nj+1))
                  std3 = (nurbcoord(3)-W_KNOT(nk))*
     &                 (  nurbcoord(3)-W_KNOT(nk+1))
                  da = (U_KNOT(ni+1) - U_KNOT(ni))*
     &                 (V_KNOT(nj+1) - V_KNOT(nj))*
     &                 (W_KNOT(nk+1) - W_KNOT(nk))
                 ! I'm in the right element
                  if ( (std1.le.1d-10).and.
     &                 (std2.le.1d-10).and.
     &                 (std3.le.1d-10).and.
     &                 (da  .ne.0d0)) then
                     icount = 0
                     do k = 0, R
                        do j = 0, Q
                           do i = 0, P
                              icount = icount + 1
                              xl(icount,:)=B_NET(ni-i,nj-j,nk-k,1:NSD)
                           enddo
                        enddo
                     enddo
                     do i = 1, NSHL
                        ul(i,:) = ug(IEN(iel,i),:)
                     enddo
                     !Get Element Shape functions and their gradients
                     shg    = 0d0  ! initialize
                     shgrad = 0d0
                     call eval_SHAPE_3D_gui_2(
     &                       iel,
     &                       nurbcoord(1), nurbcoord(2), nurbcoord(3),
     &                       shg, shgrad)
                     !Integration at this Gauss point
                     call e3int( ul, xl, shg, shgrad, ui, xi)
c                     if (myid.eq.mpi_master) then
c                         write(*,*) ul(1,:)
c                     endif

                     ! Go to next point
                     goto 2000
                  endif
               enddo 
 2000          continue
               !Store coordinates and solution
               xSOL(igauss,jgauss,kgauss,:) = xi(:)
               uSOL(igauss,jgauss,kgauss,1:NDOF) = ui(:)
            enddo
         enddo
      enddo
c...  Write results
      !Processor results
      fname = trim(trim ('var.p'//cname(istep))//cname(iproc))//'.vtu'
      ivtu=16
      OPEN (ivtu,FILE=fname,STATUS='UNKNOWN',FORM='FORMATTED')
      write(ivtu,1001) (NPTSu+1)*(NPTSv+1)*(NPTSw+1),NPTSu*NPTSv*NPTSw
      do idof=1,NDOF
         hname = '        <DataArray type="Float64" Name="'//
     &           trim ('var'//cname(idof))//'" format="ascii">'
         write(ivtu,*)hname
         do kgauss = 1, NPTSw+1
            do jgauss = 1, NPTSv+1
               do igauss = 1, NPTSu+1
                  write(ivtu,*)uSOL(igauss,jgauss,kgauss,idof)
               enddo
            enddo
         enddo
         write(ivtu,'(a)')'        </DataArray>'
      enddo
      write(ivtu,1002)NSD
      do kgauss = 1, NPTSw+1
         do jgauss = 1, NPTSv+1
            do igauss = 1, NPTSu+1
               write(ivtu,*)xSOL(igauss,jgauss,kgauss,:)
            enddo
         enddo
      enddo
      write(ivtu,1003)
      Pcount=-1
      do k = 1, NPTSw
         do j = 1, NPTSv
            do i = 1, NPTSu
               Pcount=Pcount+1
               write(ivtu,*) Pcount, 
     &              Pcount+NPTSu+1, 
     &              Pcount+(NPTSu+1)*(NPTSv+1), 
     &              Pcount+(NPTSu+1)*(NPTSv+1)+NPTSu+1, 
     &              Pcount+1, 
     &              Pcount+NPTSu+2,
     &              Pcount+(NPTSu+1)*(NPTSv+1)+1,
     &              Pcount+(NPTSu+1)*(NPTSv+1)+NPTSu+2
            enddo
            Pcount=Pcount+1
         enddo
         Pcount=Pcount+NPTSu+1 !Changed NPTSv -> NPTSu
      enddo
c     Old. Do not delete
c      do i = 1, NPTSu
c         do j = 1, NPTSv
c            do k = 1, NPTSw
c               Pcount=Pcount+1
c               write(ivtu,*) Pcount, 
c     &              Pcount+(NPTSu+1)*(NPTSv+1), 
c     &              Pcount+NPTSu+1, 
c     &              Pcount+(NPTSu+1)*(NPTSv+1)+NPTSu+1, 
c     &              Pcount+1, 
c     &              Pcount+(NPTSu+1)*(NPTSv+1)+1,
c     &              Pcount+NPTSu+2,
c     &              Pcount+(NPTSu+1)*(NPTSv+1)+NPTSu+2
c            enddo
c            Pcount=Pcount+1
c         enddo
c         Pcount=Pcount+NPTSw+1
c      enddo
      write(ivtu,1004)
      do i=1,NPTSu*NPTSv*NPTSw
         write(ivtu,*)i*8
      enddo
      write(ivtu,*) 
      write(ivtu,1005)
      do i=1,NPTSu*NPTSv*NPTSw
         write(ivtu,*)11
      enddo
      write(ivtu,1006)
      close(ivtu)

      !Parallel assembler
      if (iproc.eq.numprocs) then
         write(*,*) " Writing Parallel assembler"
         fname = trim ('var.PA' // cname(istep)) // '.pvtu'
         ivtu=19
         OPEN (ivtu,FILE=fname,STATUS='UNKNOWN',FORM='FORMATTED')
         write(ivtu,2001)
         do idof=1,NDOF
            hname = '      <PDataArray type="Float64" Name="'//
     &           trim ('var'//cname(idof))//'"/>'
            write(ivtu,*)hname
         enddo
         write(ivtu,2003)NSD
         do i=1,numprocs
            hname = '   <Piece Source="'//
     &       trim(trim ('var.p'//cname(istep))//cname(i))//'.vtu"/>'
            write(ivtu,*)hname
         enddo
         write(ivtu,2004)
         close(ivtu)
      endif

      !Time assembler
      if ((iproc.eq.numprocs).and.(istep.eq.fstep)) then
         write(*,*) " Writing temporal assembler"
         fname = 'var.TA.pvd'
         ivtu=20
         OPEN (ivtu,FILE=fname,STATUS='UNKNOWN',FORM='FORMATTED')
         write(ivtu,3001)
         do i = 1, number !inistep, fstep, inter
            hname = '   <DataSet timestep="'//
     &           trim (bname(list(1,i)))//
     &           '" file="'//
     &           trim ('var.PA'//cname(list(1,i)))//'.pvtu"/>'
            write(ivtu,*)hname
         enddo
         write(ivtu,3002)
      endif


c...  Formats
 1001 format(
     &'<?xml version="1.0"?>'/
     &'<VTKFile type="UnstructuredGrid" version="0.1" byte_order='
     &'"LittleEndian" compressor="vtkZLibDataCompressor">'/
     &'  <UnstructuredGrid>'/
     &'    <Piece NumberOfPoints="',i6,'" NumberOfCells="',i6,'">'/
     &'      <PointData>')
 1002 format(
     &'      </PointData>'/
     &'      <CellData>'/
     &'      </CellData>'/
     &'      <Points>'/
     &'        <DataArray type="Float32" NumberOfComponents="',i3,'" '
     &'format="ascii">')
 1003 format(
     &'        </DataArray>'/
     &'       </Points>'/
     &'      <Cells>'/
     &'        <DataArray type="Int32" Name="connectivity" format='
     &'"ascii">')
 1004 format(
     &'        </DataArray>'/
     &'        <DataArray type="Int32" Name="offsets" format='
     &'"ascii">')
 1005 format(
     &'        </DataArray>'/
     &'        <DataArray type="UInt8" Name="types" format='
     &'"ascii">')
 1006 format(
     &'        </DataArray>'/
     &'      </Cells>'/
     &'    </Piece>'/
     &'  </UnstructuredGrid>'/
     &'</VTKFile>')

 2001 format(
     &'<?xml version="1.0"?>'/
     &'<VTKFile type="PUnstructuredGrid" version="0.1" byte_order='
     &'"LittleEndian" compressor="vtkZLibDataCompressor">'/
     &'  <PUnstructuredGrid GhostLevel="0">'/
     &'    <PPointData>')
 2003 format(
     &'    </PPointData>'/
     &'    <CellData>'/
     &'    </CellData>'/
     &'    <PPoints>'/
     &'      <PDataArray type="Float32" NumberOfComponents="',i3,'"/>'/
     &'    </PPoints>')
 2004 format(
     &'  </PUnstructuredGrid>'/
     &'</VTKFile>')
      
 3001 format(
     &'<?xml version="1.0"?>'/
     &' <VTKFile type="Collection" version="0.1" byte_order="'
     &'LittleEndian">'/
     &'  <Collection>')
 3002 format(
     &'  </Collection>'/
     &' </VTKFile>')


      return
      end
      




!#####################################################################

      function cname (i)
      
      logical      beg
      character*10 cname,cc
      integer      il(0:8)

      integer i, ic0, ii, k
      
      ic0 = ICHAR("0")
      cc = " "
      ii = i
      
      il(0) = mod(ii,10)
      do k = 1,8
        ii = (ii - il(k-1)) / 10
        il(k) = mod (ii,10)
      enddo
      
      beg = .false.
      
      do k = 8,1,-1
        if (il(k) .ne. 0 .or. beg) then
          beg = .true.
          cc  = TRIM(cc) // CHAR(ic0 + il(k))
        endif
      enddo
      
      cc = TRIM(cc)//CHAR(ic0 + il(0))
      cname = "." // cc
      
      return
      end


!#####################################################################

      function bname (i)
      
      logical      beg
      character*10 bname,cc
      integer      il(0:8)

      integer i, ic0, ii, k
      
      ic0 = ICHAR("0")
      cc = " "
      ii = i
      
      il(0) = mod(ii,10)
      do k = 1,8
        ii = (ii - il(k-1)) / 10
        il(k) = mod (ii,10)
      enddo
      
      beg = .false.
      
      do k = 8,1,-1
        if (il(k) .ne. 0 .or. beg) then
          beg = .true.
          cc  = TRIM(cc) // CHAR(ic0 + il(k))
        endif
      enddo
      
      cc = TRIM(cc)//CHAR(ic0 + il(0))
      bname = "" // cc
      
      return
      end
