c  Subroutine eval_SHAPE.f consumes an element number and the coordinates in the
c     parent element of an integration point and returns the vector of all local
c     basis functions evaluated at the point and the matrix of gradients for all
c     nonzero bais functions with respect to parameters u and v and with respect
c     to x and y. 
c     Future modificatons should allow for the 3D case...here NSD is assumed 2.
c
c  January 20, 2004
c  J. Austin Cottrell
c  Jurijs Bazilevs
c
c  CAM Graduate Students
c  Institute for Computational Engineering Science
c  The University of Texas at Austin

      subroutine old_eval_SHAPE_3D(e,u_hat,v_hat,w_hat,shl)

      use aAdjKeep
      use common

      implicit none

c...  Global Variables
      !Element number
      integer e
      !u and v coordinates of integration point in parent element
      real*8 u_hat, v_hat, w_hat
      !Vector of Local basis function values at (u_hat, v_hat)
      real*8 shl(NSHL)

c...  Local Variables
      !1D nonrational basis functions and derivs in u and v
      real*8 N(2,P+1), M(2,Q+1), O(2,R+1)
      !u and v coordinates of integration point, denominator and derivative sums
      real*8 u, v, w, denom_sum
      !NURBS coordinates, counters for loops
      integer ni, nj, nk, i, j, k, icount

c...  Get NURBS coordinates for local node 1
      ni = INN(IEN(e,1),1)
      nj = INN(IEN(e,1),2)
      nk = INN(IEN(e,1),3)
c...  Get u and v coordinates of integration point
      u = u_hat
      v = v_hat
      w = w_hat
c...  Evaluate 1D shape functions and derivatives each direction
      call dersbasisfuns(ni,P,MCP,u,U_KNOT,N)    ! calculate in u direction
      call dersbasisfuns(nj,Q,NCP,v,V_KNOT,M)    ! calculate in v direction
      call dersbasisfuns(nk,R,OCP,w,W_KNOT,O)    ! calculate in w direction

c...  Form basis functions and derivatives dR/du and dR/dv
      icount = 0
      denom_sum = 0d+0
      do k = 0, R
        do j = 0, Q
          do i = 0, P
            icount = icount+1
            !Basis functions
            shl(icount) = N(1,P+1-i)*M(1,Q+1-j)*O(1,R+1-k)*
     &        B_NET(ni-i,nj-j,nk-k,NSD+1)
            denom_sum = denom_sum + shl(icount)
          enddo
        enddo
      enddo
c...  Divide through by denominator
      do i = 1,NSHL
        shl(i) = shl(i)/denom_sum
      enddo
      

      return
      end
      
      

