c
c Assemble global stiffness matrix from local stiffness matrix, taking 
c     advantage of sparsity. Currently assumes 2d. Will be expanded in 
c     future.
c
c modified from original code of Jurijs Bazilevs, who got it on the Russian
c     black market in exchange for a 1 lbs. can of caviar.
c
c July 1, 2003 
c J. Austin Cottrell, III
c
c Modified for 3D Nov. 15, 2003
c Jurijs Bazilevs

      subroutine FillSparseMat_3D(iel, col, row, xKebe) 
      
      use aAdjKeep
      
      include "common.h"
      
      integer iel, row(nnodz*8*(P+1)*(Q+1)*(R+1)), col(nnodz+1)
      
      integer a, b, c, d, ee, n, k, locn, i
      
      real*8 xKebe(NSD*NSD,NSHL,NSHL)
      
      
      do a = 1, NSHL
        i = IEN(iel,a)
        c = col(i)
        n = col(i+1) - c
        do b = 1, NSHL
          
          call SparseMatLoc_3D (row(c), n, IEN(iel,b), locn) 
          
          k = locn + c - 1
          
          LHSK(1,k) = LHSK(1,k) + xKebe(1,a,b)
          LHSK(2,k) = LHSK(2,k) + xKebe(2,a,b)
          LHSK(3,k) = LHSK(3,k) + xKebe(3,a,b)
          LHSK(4,k) = LHSK(4,k) + xKebe(4,a,b)
          LHSK(5,k) = LHSK(5,k) + xKebe(5,a,b)
          LHSK(6,k) = LHSK(6,k) + xKebe(6,a,b)
          LHSK(7,k) = LHSK(7,k) + xKebe(7,a,b)
          LHSK(8,k) = LHSK(8,k) + xKebe(8,a,b)
          LHSK(9,k) = LHSK(9,k) + xKebe(9,a,b)            
          
        enddo
        
      enddo
      
      return
      end
      
c*      subroutine FillSkylineMat_3D_scalar(iel, ndiag, xKebe) 
c*      
c*      use aAdjKeep
c*      
c*      include "common.h"
c*      
c*      integer iel, ndiag(NNODZ)
c*      
c*      integer a, b, c, d, ee, n, k, locn, i, j
c*      
c*      real*8 xKebe(NSD*NSD,NSHL,NSHL)
c*      
c*      
c*      do a = 1, NSHL
c*        j = IEN(iel,a)
c*        do b = 1, NSHL
c*          i = IEN(iel,b)
c*          if ( i .le. j ) then
c*            
c*            k = ndiag(j) - (j-i)
c*            
c*            LHSK(1,k) = LHSK(1,k) + xKebe(1,b,a)
c*            LHSK(2,k) = LHSK(2,k) + xKebe(2,b,a)
c*            LHSK(3,k) = LHSK(3,k) + xKebe(3,b,a)
c*            LHSK(4,k) = LHSK(4,k) + xKebe(4,b,a)
c*            LHSK(5,k) = LHSK(5,k) + xKebe(5,b,a)
c*            LHSK(6,k) = LHSK(6,k) + xKebe(6,b,a)
c*            LHSK(7,k) = LHSK(7,k) + xKebe(7,b,a)
c*            LHSK(8,k) = LHSK(8,k) + xKebe(8,b,a)
c*            LHSK(9,k) = LHSK(9,k) + xKebe(9,b,a)            
c*            
c*          endif
c*          
c*        enddo
c*        
c*      enddo
c*      
c*      return
c*      end

      
      subroutine FillSkylineMat_3D_vector(iel, ndiag, xKebe) 
      
      use aAdjKeep
      
      include "common.h"
      
      integer iel, ndiag(NSD*NNODZ)
      
      integer a, b, c, d, ee, n, k, locn, i, j,
     &  jv1, jv2, jv3, k1, k2, k3, k4, k5, k6, k7, k8, k9
      
      real*8 xKebe(NSD*NSD,NSHL,NSHL)
      
      
      do a = 1, NSHL
        j = IEN(iel,a)
        jv1 = 3*(j-1)+1
        jv2 = jv1+1
        jv3 = jv2+1
        do b = 1, NSHL
          i = IEN(iel,b)
          
          if ( i .lt. j ) then  ! 9 entries
            
            k7 = ndiag(jv1) - 3*(j-i) + 2
            k4 = ndiag(jv1) - 3*(j-i) + 1
            k1 = ndiag(jv1) - 3*(j-i) 
            
            k8 = ndiag(jv2) - 3*(j-i) + 1
            k5 = ndiag(jv2) - 3*(j-i) 
            k2 = ndiag(jv2) - 3*(j-i) - 1
            
            k9 = ndiag(jv3) - 3*(j-i)
            k6 = ndiag(jv3) - 3*(j-i) - 1
            k3 = ndiag(jv3) - 3*(j-i) - 2
            
            LHSKV(k1) = LHSKV(k1) + xKebe(1,b,a)
            LHSKV(k2) = LHSKV(k2) + xKebe(2,b,a)
            LHSKV(k3) = LHSKV(k3) + xKebe(3,b,a)
            LHSKV(k4) = LHSKV(k4) + xKebe(4,b,a)
            LHSKV(k5) = LHSKV(k5) + xKebe(5,b,a)
            LHSKV(k6) = LHSKV(k6) + xKebe(6,b,a)
            LHSKV(k7) = LHSKV(k7) + xKebe(7,b,a)
            LHSKV(k8) = LHSKV(k8) + xKebe(8,b,a)
            LHSKV(k9) = LHSKV(k9) + xKebe(9,b,a)
            
          else if (i.eq.j) then ! 6 entries (diagonal block)
            
            k1 = ndiag(jv1)
            k2 = ndiag(jv2) - 1
            k3 = ndiag(jv3) - 2
            
            k5 = ndiag(jv2)
            k6 = ndiag(jv3) - 1
            
            k9 = ndiag(jv3)
            
            LHSKV(k1) = LHSKV(k1) + xKebe(1,b,a)
            LHSKV(k2) = LHSKV(k2) + xKebe(2,b,a)
            LHSKV(k3) = LHSKV(k3) + xKebe(3,b,a)
            
            LHSKV(k5) = LHSKV(k5) + xKebe(5,b,a)
            LHSKV(k6) = LHSKV(k6) + xKebe(6,b,a)
            
            
            LHSKV(k9) = LHSKV(k9) + xKebe(9,b,a)
            
          endif
          
        enddo
        
      enddo
      
      return
      end
      
      subroutine FillSkylineMat_3D_vector_iper(iel, ndiag, xKebe) 
      
      use aAdjKeep
      
      include "common.h"
      
      integer iel, ndiag(NSD*NNODZ)
      
      integer a, b, c, d, ee, n, k, locn, i, j,
     &  jv1, jv2, jv3, k1, k2, k3, k4, k5, k6, k7, k8, k9,
     &  im, jm, jv1m, jv2m, jv3m
      
      real*8 xKebe(NSD*NSD,NSHL,NSHL)
      
      
      do a = 1, NSHL
        
        j = IEN(iel,a)
        jv1 = 3*(j-1)+1
        jv2 = jv1+1
        jv3 = jv2+1
        
        jm = IPER(j)
        jv1m = 3*(jm-1)+1
        jv2m = jv1m+1
        jv3m = jv2m+1
        do b = 1, NSHL
          i = IEN(iel,b)
          im = IPER(i)
          
          if (im .lt. jm) then  ! 9 entries
            
            k7 = ndiag(jv1m) - 3*(jm-im) + 2
            k4 = ndiag(jv1m) - 3*(jm-im) + 1
            k1 = ndiag(jv1m) - 3*(jm-im) 
            
            k8 = ndiag(jv2m) - 3*(jm-im) + 1
            k5 = ndiag(jv2m) - 3*(jm-im) 
            k2 = ndiag(jv2m) - 3*(jm-im) - 1
            
            k9 = ndiag(jv3m) - 3*(jm-im)
            k6 = ndiag(jv3m) - 3*(jm-im) - 1
            k3 = ndiag(jv3m) - 3*(jm-im) - 2
            
            LHSKV(k1) = LHSKV(k1) + xKebe(1,b,a)
            LHSKV(k2) = LHSKV(k2) + xKebe(2,b,a)
            LHSKV(k3) = LHSKV(k3) + xKebe(3,b,a)
            LHSKV(k4) = LHSKV(k4) + xKebe(4,b,a)
            LHSKV(k5) = LHSKV(k5) + xKebe(5,b,a)
            LHSKV(k6) = LHSKV(k6) + xKebe(6,b,a)
            LHSKV(k7) = LHSKV(k7) + xKebe(7,b,a)
            LHSKV(k8) = LHSKV(k8) + xKebe(8,b,a)
            LHSKV(k9) = LHSKV(k9) + xKebe(9,b,a)
            
          else if (im.eq.jm) then ! 6 entries (diagonal block, master only)
            
            k1 = ndiag(jv1m)
            k2 = ndiag(jv2m) - 1
            k3 = ndiag(jv3m) - 2
            
            k5 = ndiag(jv2m)
            k6 = ndiag(jv3m) - 1
            
            k9 = ndiag(jv3m)
            
            LHSKV(k1) = LHSKV(k1) + xKebe(1,b,a)
            LHSKV(k2) = LHSKV(k2) + xKebe(2,b,a)
            LHSKV(k3) = LHSKV(k3) + xKebe(3,b,a)
            
            LHSKV(k5) = LHSKV(k5) + xKebe(5,b,a)
            LHSKV(k6) = LHSKV(k6) + xKebe(6,b,a)
            
            
            LHSKV(k9) = LHSKV(k9) + xKebe(9,b,a)
            
            if (IPER(j).ne.j) then
              
              k1 = ndiag(jv1)
              k2 = ndiag(jv2) - 1
              k3 = ndiag(jv3) - 2
              
              k5 = ndiag(jv2)
              k6 = ndiag(jv3) - 1
              
              k9 = ndiag(jv3)
              
              LHSKV(k1) = 1d+0
              LHSKV(k5) = 1d+0
              LHSKV(k9) = 1d+0
              
c              LHSKV(k2) = 0d+0
c              LHSKV(k3) = 0d+0
c              LHSKV(k6) = 0d+0
              
            endif
            
          endif
          
        enddo
        
      enddo
      
      return
      end
      
