c     Modified Jan. 20, 2004

      subroutine IntElmAss_3D(col, row)

      use aAdjKeep

      include "common.h"
      

c...  Local variables
      integer iel, igauss, jgauss, kgauss, i, j, k
      integer row(NNODZ*8*(P+1)*(Q+1)*(R+1)), col(NNODZ+1), ni,nj, nk
      real*8 shl(NSHL), shg(NSHL), shgradl(NSHL,NSD),
     &     shgradg(NSHL,NSD)
      real*8 gp(NGAUSS), gw(NGAUSS), gwt, da
      real*8 lambda, numod, Emod, mu, fx, fy, fz, yl(NSHL,NSD)
      real*8 xKebe(NSD*NSD,NSHL,NSHL), Rhs(NSD,NSHL), volm, Pload
        

c...  get Gaussian points and weights
      gp = 0d+0
      gw = 0d+0
      volm = 0d+0               ! Volume of the solid

      NEL_NZA = 0               ! Elements of non-zero area

      call genGPandGW(gp,gw)

c...  loop over elements
      do iel = 1, NEL
        
c...  Check to see if current element has nonzero area
         ni = INN(IEN(iel,1),1)       ! get NURB coordinates
         nj = INN(IEN(iel,1),2)
         nk = INN(IEN(iel,1),3)
         
         if ((U_KNOT(ni).ne.U_KNOT(ni+1)).and.
     &     (V_KNOT(nj).ne.V_KNOT(nj+1)).and.
     &     (W_KNOT(nk).ne.W_KNOT(nk+1))) then
            
           NEL_NZA = NEL_NZA + 1
           
           da = (U_KNOT(ni+1) - U_KNOT(ni))*
     &       (V_KNOT(nj+1) - V_KNOT(nj))*
     &       (W_KNOT(nk+1) - W_KNOT(nk))/8d+0  ! used in calculating 
                                ! quadrature points. The factor of 8d+0
                                ! comes from mapping from the [-1,1]
                                ! line onto a real segment...
                        
c...     Set up element parameters
            Emod = EY(iel)
            numod = NU(iel)
            
            fx = LD_el(iel,1)
            fy = LD_el(iel,2)
            fz = LD_el(iel,3)
            
            lambda = numod*Emod/((1d+0+numod)*(1d+0-2d+0*numod))
            mu = Emod/(2d+0*(1d+0+numod)) ! PDE
            
            xKebe = 0d+0           ! initialize local stiffness matrix
            Rhs = 0d+0             ! initialize local load vector

         
c...        Loop over integration points (NGAUSS in each direction)
            do igauss = 1, NGAUSS
              do jgauss = 1, NGAUSS
                do kgauss = 1, NGAUSS

c...           Get Element Shape functions and their gradients
                  
                  shl = 0d+0    ! initialize
                  shg = 0d+0
                  shgradl = 0d+0
                  shgradg = 0d+0


                  call eval_SHAPE_3D(iel, gp(igauss), gp(jgauss),
     &              gp(kgauss), shl, shgradl,shgradg)
                  shg = shl
   
         
c...              Calculate given element stiffness matrix and force vector
                  
                  gwt = gw(igauss)*gw(jgauss)*gw(kgauss)*da
                  
                  call e3LHS_3D(lambda, mu, gwt, 
     &              shgradg, xKebe)

c*c-----------------------------------------------------------c                  
c*c...              user defined forcing
c*
c*                  call e3Force(iel, shl, lambda, mu, fx, fy)
c*
c*c...              end user defined forcing
c*c-----------------------------------------------------------c                  
                  call e3Rhs_3D(fx, fy, fz, gwt, shg, Rhs,volm)
                  
                enddo
              enddo
           enddo        

c-------------------------------------------------------------c
c
c...       Pinched Cylinder Load           
           
                                ! evaluate basis at point load

           if (((ni.eq.MCP).and.(nk.eq.OCP)).and.
     &      ((abs(V_KNOT(nj)-(0.5)).le.(1d-8)).or.
     &       ((V_KNOT(nj).lt.0.5).and.(V_KNOT(nj+1).gt.0.5)))) then

             if (abs(V_KNOT(nj)-(0.5)).le.(1d-8)) then
               call eval_SHAPE_3D(iel,1d+0,-1d+0,1d+0,shl,shgradl,
     &           shgradg)
             else
               call eval_SHAPE_3D(iel,0d+0,-1d+0,1d+0,shl,shgradl,
     &           shgradg)
             endif
               
             shg = shl
             Pload = (1d+0)/4.0
c             Rhs(1,:) = Rhs(1,:)+shg(:)*Pload*0d+0
             Rhs(2,:) = Rhs(2,:)+shg(:)*Pload*(-1d+0)
c             Rhs(3,:) = Rhs(3,:)+shg(:)*Pload*0d+0
             
           endif
c...      User Defined
c           
c*c------------------------------------------------------------c

c*c-------------------------------------------------------------c
c*c
c*c...       Pinched Hemisphere Load 1           
c*           
c*                                ! evaluate basis at point load
c*
c*           if (((ni.eq.p+1).and.(nj.eq.q+1)).and.
c*     &       ((abs(W_KNOT(nk)-0.5).le.(1d-8)).or.
c*     &       (W_KNOT(nk).lt.0.5).and.(W_KNOT(nk+1).gt.0.5))) then
c*           
c*             if (abs(W_KNOT(nk)-0.5).le.(1d-8)) then
c*               call eval_SHAPE_3D(iel,-1d+0,-1d+0,-1d+0,shl,shgradl,
c*     &           shgradg)
c*             else
c*               call eval_SHAPE_3D(iel,-1d+0,-1d+0,0d+0,shl,shgradl,
c*     &           shgradg)
c*             endif
c*           
c*             shg = shl
c*             Pload = 1d+0
c*             Rhs(1,:) = Rhs(1,:)+shg(:)*Pload*(1d+0)
c*c            Rhs(2,:) = Rhs(2,:)+shg(:)*Pload*0d+0
c*c            Rhs(3,:) = Rhs(3,:)+shg(:)*Pload*0d+0
c*             
c*           endif
c*c...      User Defined
c*c           
c*c------------------------------------------------------------c
c*
c*c-------------------------------------------------------------c
c*c
c*c...       Pinched Hemisphere Load  2         
c*           
c*                                ! evaluate basis at point load
c*           
c*           if (((ni.eq.MCP).and.(nj.eq.q+1)).and.
c*     &       ((abs(W_KNOT(nk)-0.5).le.(1d-8)).or.
c*     &       (W_KNOT(nk).lt.0.5).and.(W_KNOT(nk+1).gt.0.5))) then
c*             
c*             if (abs(W_KNOT(nk)-0.5).le.(1d-8)) then
c*               call eval_SHAPE_3D(iel,1d+0,-1d+0,-1d+0,shl,shgradl,
c*     &           shgradg)
c*             else
c*               call eval_SHAPE_3D(iel,1d+0,-1d+0,0d+0,shl,shgradl,
c*     &           shgradg)
c*             endif
c*               
c*             shg = shl
c*             Pload = 1d+0
c*c             Rhs(1,:) = Rhs(1,:)+shg(:)*Pload*0d+0
c*             Rhs(2,:) = Rhs(2,:)+shg(:)*Pload*(-1d+0)
c*c             Rhs(3,:) = Rhs(3,:)+shg(:)*Pload*0d+0
c*             
c*           endif
c*c...      User Defined
c*c           
c*c------------------------------------------------------------c           

           
           do i = 1, NSHL
              yl(i,:) = DIR_BC(IEN(iel,i),:)
           enddo
              
              
           do i = 1, NSHL
              do j = 1, NSHL
                 Rhs(1,i) = Rhs(1,i) - xKebe(1,i,j)*yl(j,1) -
     &                xKebe(2,i,j)*yl(j,2) - xKebe(3,i,j)*yl(j,3)
                 Rhs(2,i) = Rhs(2,i) - xKebe(4,i,j)*yl(j,1) -
     &                xKebe(5,i,j)*yl(j,2) - xKebe(6,i,j)*yl(j,3)
                 Rhs(3,i) = Rhs(3,i) - xKebe(7,i,j)*yl(j,1) -
     &                xKebe(8,i,j)*yl(j,2) - xKebe(9,i,j)*yl(j,3)
              enddo
           enddo
              
              
              
              
c...  Modify local stiffness matrix for Dirichlet boundary conditions
           call BCLhs_3D(iel, xKebe, Rhs)

c...  assemble into the Sparse Global Stiffness Matrix and Rhs Vector
              
           call FillSparseMat_3D (iel, col, row, xKebe) ! Assemble stiffness
           call LocaltoGlobal_3D (iel, Rhs) ! Assemble load vector
              
        endif
        
      enddo

      write(*,*) "Volume of Solid =    ", volm
      
      return
      end
      
c     Modified Jan. 20, 2004

      
      subroutine IntElmAss_3D_Skyline(ndiag)
      
      use aAdjKeep
      
      include "common.h"
      
      
c...  Local variables
      integer iel, igauss, jgauss, kgauss, i, j, k
      integer ndiag(NSD*NNODZ), ni,nj, nk
      real*8 shl(NSHL), shg(NSHL), shgradl(NSHL,NSD),
     &     shgradg(NSHL,NSD)
      real*8 gp(NGAUSS), gw(NGAUSS), gwt, da
      real*8 lambda, numod, Emod, mu, fx, fy, fz, yl(NSHL,NSD)
      real*8 xKebe(NSD*NSD,NSHL,NSHL), Rhs(NSD,NSHL), volm, Pload
        

c...  get Gaussian points and weights
      gp = 0d+0
      gw = 0d+0
      volm = 0d+0

      NEL_NZA = 0               ! Elements of non-zero area

      call genGPandGW(gp,gw)

c...  loop over elements
      do iel = 1, NEL
        
c...  Check to see if current element has nonzero area
         ni = INN(IEN(iel,1),1)       ! get NURB coordinates
         nj = INN(IEN(iel,1),2)
         nk = INN(IEN(iel,1),3)
         
         if ((U_KNOT(ni).ne.U_KNOT(ni+1)).and.
     &     (V_KNOT(nj).ne.V_KNOT(nj+1)).and.
     &     (W_KNOT(nk).ne.W_KNOT(nk+1))) then
            
           NEL_NZA = NEL_NZA + 1
           
           da = (U_KNOT(ni+1) - U_KNOT(ni))*
     &       (V_KNOT(nj+1) - V_KNOT(nj))*
     &       (W_KNOT(nk+1) - W_KNOT(nk))/8d+0  ! used in calculating 
                                ! quadrature points. The factor of 8d+0
                                ! comes from mapping from the [-1,1]
                                ! line onto a real segment...
                        
c...     Set up element parameters
            Emod = EY(iel)
            numod = NU(iel)
            
            fx = LD_el(iel,1)
            fy = LD_el(iel,2)
            fz = LD_el(iel,3)
            
            lambda = numod*Emod/((1d+0+numod)*(1d+0-2d+0*numod))
            mu = Emod/(2d+0*(1d+0+numod)) ! PDE
            
            xKebe = 0d+0           ! initialize local stiffness matrix
            Rhs = 0d+0             ! initialize local load vector

         
c...        Loop over integration points (NGAUSS in each direction)
            do igauss = 1, NGAUSS
              do jgauss = 1, NGAUSS
                do kgauss = 1, NGAUSS

c...           Get Element Shape functions and their gradients
                  
                  shl = 0d+0    ! initialize
                  shg = 0d+0
                  shgradl = 0d+0
                  shgradg = 0d+0


                  call eval_SHAPE_3D(iel, gp(igauss), gp(jgauss),
     &              gp(kgauss), shl, shgradl,shgradg)
                  shg = shl
   
         
c...              Calculate given element stiffness matrix and force vector
                  
                  gwt = gw(igauss)*gw(jgauss)*gw(kgauss)*da
                  
                  call e3LHS_3D(lambda, mu, gwt, 
     &              shgradg, xKebe)

c*c-----------------------------------------------------------c                  
c*c...              user defined forcing
c*
c*                  call e3Force(iel, shl, lambda, mu, fx, fy)
c*
c*c...              end user defined forcing
c*c-----------------------------------------------------------c                  
                  call e3Rhs_3D(fx, fy, fz, gwt, shg, Rhs, volm)
                  
                enddo
              enddo
           enddo

c*c-------------------------------------------------------------c
c*c
c*c...       Pinched Cylinder Load           
c*           
c*                                ! evaluate basis at point load
c*
c*           if (((ni.eq.MCP).and.(nk.eq.OCP)).and.
c*     &      (abs(V_KNOT(nj)-(0.5)).le.(1d-8))) then
c*             
c*             call eval_SHAPE_3D(iel,1d+0,-1d+0,1d+0,shl,shgradl,shgradg)
c*             shg = shl
c*             Pload = (1d+0)/4.0
c*c             Rhs(1,:) = Rhs(1,:)+shg(:)*Pload*0d+0
c*             Rhs(2,:) = Rhs(2,:)+shg(:)*Pload*(-1d+0)
c*c             Rhs(3,:) = Rhs(3,:)+shg(:)*Pload*0d+0
c*             
c*           endif
c*c...      User Defined
c*c           
c*c------------------------------------------------------------c


c-------------------------------------------------------------c
c
c...       Pinched Cylinder Load           
           
                                ! evaluate basis at point load

           if (((ni.eq.MCP).and.(nk.eq.OCP)).and.
     &      ((abs(V_KNOT(nj)-(0.5)).le.(1d-8)).or.
     &       ((V_KNOT(nj).lt.0.5).and.(V_KNOT(nj+1).gt.0.5)))) then

             if (abs(V_KNOT(nj)-(0.5)).le.(1d-8)) then
               call eval_SHAPE_3D(iel,1d+0,-1d+0,1d+0,shl,shgradl,
     &           shgradg)
             else
               call eval_SHAPE_3D(iel,0d+0,-1d+0,1d+0,shl,shgradl,
     &           shgradg)
             endif
               
             shg = shl
             Pload = (1d+0)/4.0
c             Rhs(1,:) = Rhs(1,:)+shg(:)*Pload*0d+0
             Rhs(2,:) = Rhs(2,:)+shg(:)*Pload*(-1d+0)
c             Rhs(3,:) = Rhs(3,:)+shg(:)*Pload*0d+0
             
           endif
c...      User Defined
c           
c*c------------------------------------------------------------c


c-------------------------------------------------------------c
c
c...       Pinched Hemisphere Load  2         
           
                                ! evaluate basis at point load
           
           if (((ni.eq.MCP).and.(nj.eq.q+1)).and.
     &       ((abs(W_KNOT(nk)-0.5).le.(1d-8)).or.
     &       (W_KNOT(nk).lt.0.5).and.(W_KNOT(nk+1).gt.0.5))) then
             
             if (abs(W_KNOT(nk)-0.5).le.(1d-8)) then
               call eval_SHAPE_3D(iel,1d+0,-1d+0,-1d+0,shl,shgradl,
     &           shgradg)
             else
               call eval_SHAPE_3D(iel,1d+0,-1d+0,0d+0,shl,shgradl,
     &           shgradg)
             endif
               
             shg = shl
             Pload = 1d+0
c             Rhs(1,:) = Rhs(1,:)+shg(:)*Pload*0d+0
             Rhs(2,:) = Rhs(2,:)+shg(:)*Pload*(-1d+0)
c             Rhs(3,:) = Rhs(3,:)+shg(:)*Pload*0d+0
             
           endif
c...      User Defined
c           
c------------------------------------------------------------c   

           
           
           do i = 1, NSHL
              yl(i,:) = DIR_BC(IEN(iel,i),:)
           enddo
              
              
           do i = 1, NSHL
              do j = 1, NSHL
                 Rhs(1,i) = Rhs(1,i) - xKebe(1,i,j)*yl(j,1) -
     &                xKebe(2,i,j)*yl(j,2) - xKebe(3,i,j)*yl(j,3)
                 Rhs(2,i) = Rhs(2,i) - xKebe(4,i,j)*yl(j,1) -
     &                xKebe(5,i,j)*yl(j,2) - xKebe(6,i,j)*yl(j,3)
                 Rhs(3,i) = Rhs(3,i) - xKebe(7,i,j)*yl(j,1) -
     &                xKebe(8,i,j)*yl(j,2) - xKebe(9,i,j)*yl(j,3)
              enddo
           enddo
              
              
              
              
c...  Modify local stiffness matrix for Dirichlet boundary conditions
           call BCLhs_3D(iel, xKebe, Rhs)

c...  assemble into the Sparse Global Stiffness Matrix and Rhs Vector
              
           call FillSkylineMat_3D_vector_iper(iel, ndiag, xKebe) ! Assemble stiffness
           call LocaltoGlobal_3D (iel, Rhs) ! Assemble load vector
              
        endif
        
      enddo

      write(*,*) "Volume of Solid =    ", volm
      
      return
      end
