
      
      subroutine SparseCG_3D(colvec, rowvec, soln)
      
      use aAdjKeep
      
      include "common.h"
      
      real*8, allocatable :: lhsKdiag(:,:)
      
      integer colvec(NNODZ+1), rowvec(NNODZ*8*(P+1)*(Q+1)*(R+1))
      integer n, i, j, k, iter
      real*8  rhstmp(NNODZ,3), prodtmp(NNODZ,3), rr, rr1, rr2, rr3, 
     &  pp, alpha, soln(NNODZ,3), tmprr, beta, pv(NNODZ,3), rr0,
     &  tauk, taukm1, zs(NNODZ,3)
      
      
      allocate(lhsKdiag(3,NNODZ))
      
c...  extract diagonal vector
      
      do i = 1, NNODZ
        do j = colvec(i), colvec(i+1)-1
          n = rowvec(j)
          if (n.eq.i) then
            lhsKdiag(1,i) = 1d+0/LHSK(1,j)
            lhsKdiag(2,i) = 1d+0/LHSK(5,j)
            lhsKdiag(3,i) = 1d+0/LHSK(9,j)
          endif
        enddo
      enddo
      
      
c...  communicate the diagonal
      
      do i = 1, NNODZ           ! If a node is a slave
        if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3)) then 
          lhsKdiag(:,IPER(i)) = lhsKdiag(:,IPER(i)) + lhsKdiag(:,i) ! Ma = Ma+Sl
        endif
      enddo
      
      do i = 1, NNODZ        
        if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3)) then
          lhsKdiag(:,i) = lhsKdiag(:,IPER(i))
        endif        
      enddo      

      
      rhstmp(:,1) = RHSG(:,1)
      rhstmp(:,2) = RHSG(:,2)
      rhstmp(:,3) = RHSG(:,3)
      
      soln = 0d+0
      rr = 0d+0
      rr1 = 0d+0
      rr2 = 0d+0
      rr3 = 0d+0
      
      do n = 1, NNODZ
        rr1 = rr1 + rhstmp(n,1)*rhstmp(n,1)
        rr2 = rr2 + rhstmp(n,2)*rhstmp(n,2)
        rr3 = rr3 + rhstmp(n,3)*rhstmp(n,3)
      enddo
      
      rr = rr1+rr2+rr3
      rr0 = rr
      
      do iter = 1, 5000
        

ccc        write(*,*) iter, sqrt(rr/rr0)
        
        do i = 1, NNODZ
          zs(i,1) = rhstmp(i,1)*lhsKdiag(1,i)
          zs(i,2) = rhstmp(i,2)*lhsKdiag(2,i)
          zs(i,3) = rhstmp(i,3)*lhsKdiag(3,i)
        enddo
        
        tauk = 0d+0

        do i = 1, NNODZ
          do j = 1, 3
            tauk = tauk + zs(i,j)*rhstmp(i,j)
          enddo
        enddo
        
        if(iter.eq.1) then
          beta = 0d+0
          pv = zs
        else
          beta = tauk/taukm1
          pv(:,:) = zs(:,:) + beta*pv(:,:)
        endif
          
c...    Periodicity (Slave = Master)         
        
        do i = 1, NNODZ
          
          if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3))
     &      then
            pv(i,:) = pv(IPER(i),:) ! Slave = Master
          endif
          
        enddo
        
c...    Product
        
        call SparseProd_3D (colvec, rowvec, pv, prodtmp)
        
        
c...    Communicate to Masters, Zero out Slaves
        
        do i = 1, NNODZ
          
          if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3))
     &      then
            
            prodtmp(IPER(i),:) = prodtmp(IPER(i),:) + 
     &        prodtmp(i,:)      ! Master = Master+Slave
            prodtmp(i,:) = 0d+0 ! Slave = zero
            
          endif
          
        enddo           
        
c...    
        
        pp = 0d+0
        rr1 = 0d+0
        rr2 = 0d+0
        rr3 = 0d+0
        
        do n = 1, NNODZ
          rr1 = rr1 + pv(n,1)*prodtmp(n,1)
          rr2 = rr2 + pv(n,2)*prodtmp(n,2)
          rr3 = rr3 + pv(n,3)*prodtmp(n,3)
        enddo
        
        pp = rr1 + rr2 + rr3
        
        alpha = tauk/pp
        
c....   calculate the next guess
        
        soln(:,1) = soln(:,1) + alpha*pv(:,1)
        soln(:,2) = soln(:,2) + alpha*pv(:,2)
        soln(:,3) = soln(:,3) + alpha*pv(:,3)
        
c....   calculate new res. and dot prod. 
        
        rhstmp(:,1) = rhstmp(:,1) - alpha*prodtmp(:,1)
        rhstmp(:,2) = rhstmp(:,2) - alpha*prodtmp(:,2)
        rhstmp(:,3) = rhstmp(:,3) - alpha*prodtmp(:,3)
        
        tmprr = rr
        
        rr = 0
        rr1 = 0
        rr2 = 0
        rr3 = 0
        
        do n = 1, NNODZ
          rr1 = rr1 + rhstmp(n,1)*rhstmp(n,1)
          rr2 = rr2 + rhstmp(n,2)*rhstmp(n,2)
          rr3 = rr3 + rhstmp(n,3)*rhstmp(n,3)
        enddo
        
        rr = rr1 + rr2 + rr3
        
c....   check for convergence 

        taukm1 = tauk
        
        if(sqrt(rr/rr0).lt.0.000000000001) goto 6000
        
      enddo
      
 6000 continue
      
c...  communicate solution
      
      do i = 1, NNODZ
        
        if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3))
     &    then
          soln(i,:) = soln(IPER(i),:) ! Slave = Master
        endif
        
      enddo
      
      deallocate(lhsKdiag)
      
      write(*,9000) iter, sqrt(rr / rr0)
      
      return
 9000 format(20x,'  number of iterations:', i10,/,
     &  20x,'    residual reduction:', 2x,e10.2)
      
      end

      
      subroutine SparseCG_BDIAG_3D(colvec, rowvec, soln)
      
      use aAdjKeep
      
      include "common.h"
      
      real*8, allocatable :: lhsKBdiag(:,:,:)
      
      integer colvec(NNODZ+1), rowvec(NNODZ*8*(P+1)*(Q+1)*(R+1))
      integer n, i, j, k, iter
      real*8  rhstmp(NNODZ,3), prodtmp(NNODZ,3), rr, rr1, rr2, rr3, 
     &  pp, alpha, soln(NNODZ,3), tmprr, beta, pv(NNODZ,3), rr0,
     &  tauk, taukm1, zs(NNODZ,3), Binv(3,3), tmp
      
      
      allocate(lhsKBdiag(3,3,NNODZ))
      
c...  extract block-diagonal matrix vector
      
      do i = 1, NNODZ
        do j = colvec(i), colvec(i+1)-1
          n = rowvec(j)
          if (n.eq.i) then
            
            lhsKBdiag(1,1,i) = LHSK(1,j)
            lhsKBdiag(2,2,i) = LHSK(5,j)
            lhsKBdiag(3,3,i) = LHSK(9,j)
            
            lhsKBdiag(1,2,i) = LHSK(2,j)
            lhsKBdiag(1,3,i) = LHSK(3,j)
            lhsKBdiag(2,1,i) = LHSK(4,j)
            lhsKBdiag(2,3,i) = LHSK(6,j)
            lhsKBdiag(3,1,i) = LHSK(7,j)
            lhsKBdiag(3,2,i) = LHSK(8,j)
            
          endif
        enddo
      enddo
      
      
c...  communicate the block-diagonal
      
      do i = 1, NNODZ           ! If a node is a slave
        if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3)) then 
          lhsKBdiag(:,:,IPER(i)) = lhsKBdiag(:,:,IPER(i))
     &      + lhsKBdiag(:,:,i)  ! Ma = Ma+Sl
        endif
      enddo
      
      do i = 1, NNODZ        
        if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3)) then
          lhsKBdiag(:,:,i) = lhsKBdiag(:,:,IPER(i))
        endif        
      enddo      

c...  invert block-diagonal

      Binv = 0d+0
      
      do i = 1, NNODZ
        
        Binv(1,1) =   lhsKBdiag(2,2,i) * lhsKBdiag(3,3,i) 
     &    - lhsKBdiag(3,2,i) * lhsKBdiag(2,3,i)
        Binv(1,2) =   lhsKBdiag(3,2,i) * lhsKBdiag(1,3,i) 
     &    - lhsKBdiag(1,2,i) * lhsKBdiag(3,3,i)
        Binv(1,3) =  lhsKBdiag(1,2,i) * lhsKBdiag(2,3,i) 
     &    - lhsKBdiag(1,3,i) * lhsKBdiag(2,2,i)
        tmp          = 1d+0 / ( Binv(1,1) * lhsKBdiag(1,1,i) 
     &    + Binv(1,2) * lhsKBdiag(2,1,i)  
     &    + Binv(1,3) * lhsKBdiag(3,1,i) )
        Binv(1,1) = Binv(1,1) * tmp
        Binv(1,2) = Binv(1,2) * tmp
        Binv(1,3) = Binv(1,3) * tmp
        Binv(2,1) = (lhsKBdiag(2,3,i) * lhsKBdiag(3,1,i) 
     &    - lhsKBdiag(2,1,i) * lhsKBdiag(3,3,i)) * tmp
        Binv(2,2) = (lhsKBdiag(1,1,i) * lhsKBdiag(3,3,i) 
     &    - lhsKBdiag(3,1,i) * lhsKBdiag(1,3,i)) * tmp
        Binv(2,3) = (lhsKBdiag(2,1,i) * lhsKBdiag(1,3,i) 
     &    - lhsKBdiag(1,1,i) * lhsKBdiag(2,3,i)) * tmp
        Binv(3,1) = (lhsKBdiag(2,1,i) * lhsKBdiag(3,2,i) 
     &    - lhsKBdiag(2,2,i) * lhsKBdiag(3,1,i)) * tmp
        Binv(3,2) = (lhsKBdiag(3,1,i) * lhsKBdiag(1,2,i) 
     &    - lhsKBdiag(1,1,i) * lhsKBdiag(3,2,i)) * tmp
        Binv(3,3) = (lhsKBdiag(1,1,i) * lhsKBdiag(2,2,i) 
     &    - lhsKBdiag(1,2,i) * lhsKBdiag(2,1,i)) * tmp
        
        lhsKBdiag(:,:,i) = Binv(:,:)
        
      enddo
      
      rhstmp(:,1) = RHSG(:,1)
      rhstmp(:,2) = RHSG(:,2)
      rhstmp(:,3) = RHSG(:,3)
      
      soln = 0d+0
      rr = 0d+0
      rr1 = 0d+0
      rr2 = 0d+0
      rr3 = 0d+0
      
      do n = 1, NNODZ
        rr1 = rr1 + rhstmp(n,1)*rhstmp(n,1)
        rr2 = rr2 + rhstmp(n,2)*rhstmp(n,2)
        rr3 = rr3 + rhstmp(n,3)*rhstmp(n,3)
      enddo
      
      rr = rr1+rr2+rr3
      rr0 = rr
      
      do iter = 1, 90000
        
        
ccc        write(*,*) iter, sqrt(rr/rr0)
        
c...    Premultiply residual by inverse of Bdiag
        
        do i = 1, NNODZ
          zs(i,1) = lhsKBdiag(1,1,i)*rhstmp(i,1) +
     &      lhsKBdiag(1,2,i)*rhstmp(i,2) + lhsKBdiag(1,3,i)*rhstmp(i,3)
          zs(i,2) = lhsKBdiag(2,1,i)*rhstmp(i,1) +
     &      lhsKBdiag(2,2,i)*rhstmp(i,2) + lhsKBdiag(2,3,i)*rhstmp(i,3)
          zs(i,3) = lhsKBdiag(3,1,i)*rhstmp(i,1) +
     &      lhsKBdiag(3,2,i)*rhstmp(i,2) + lhsKBdiag(3,3,i)*rhstmp(i,3)
        enddo
        
        tauk = 0d+0

        do i = 1, NNODZ
          do j = 1, 3
            tauk = tauk + zs(i,j)*rhstmp(i,j)
          enddo
        enddo
        
        if(iter.eq.1) then
          beta = 0d+0
          pv = zs
        else
          beta = tauk/taukm1
          pv(:,:) = zs(:,:) + beta*pv(:,:)
        endif
          
c...    Periodicity (Slave = Master)         
        
        do i = 1, NNODZ
          
          if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3))
     &      then
            pv(i,:) = pv(IPER(i),:) ! Slave = Master
          endif
          
        enddo
        
c...    Product
        
        call SparseProd_3D (colvec, rowvec, pv, prodtmp)
        
        
c...    Communicate to Masters, Zero out Slaves
        
        do i = 1, NNODZ
          
          if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3))
     &      then
            
            prodtmp(IPER(i),:) = prodtmp(IPER(i),:) + 
     &        prodtmp(i,:)      ! Master = Master+Slave
            prodtmp(i,:) = 0d+0 ! Slave = zero
            
          endif
          
        enddo           
        
c...    
        
        pp = 0d+0
        rr1 = 0d+0
        rr2 = 0d+0
        rr3 = 0d+0
        
        do n = 1, NNODZ
          rr1 = rr1 + pv(n,1)*prodtmp(n,1)
          rr2 = rr2 + pv(n,2)*prodtmp(n,2)
          rr3 = rr3 + pv(n,3)*prodtmp(n,3)
        enddo
        
        pp = rr1 + rr2 + rr3
        
        alpha = tauk/pp
        
c....   calculate the next guess
        
        soln(:,1) = soln(:,1) + alpha*pv(:,1)
        soln(:,2) = soln(:,2) + alpha*pv(:,2)
        soln(:,3) = soln(:,3) + alpha*pv(:,3)
        
c....   calculate new res. and dot prod. 
        
        rhstmp(:,1) = rhstmp(:,1) - alpha*prodtmp(:,1)
        rhstmp(:,2) = rhstmp(:,2) - alpha*prodtmp(:,2)
        rhstmp(:,3) = rhstmp(:,3) - alpha*prodtmp(:,3)
        
        tmprr = rr
        
        rr = 0
        rr1 = 0
        rr2 = 0
        rr3 = 0
        
        do n = 1, NNODZ
          rr1 = rr1 + rhstmp(n,1)*rhstmp(n,1)
          rr2 = rr2 + rhstmp(n,2)*rhstmp(n,2)
          rr3 = rr3 + rhstmp(n,3)*rhstmp(n,3)
        enddo
        
        rr = rr1 + rr2 + rr3
        
c....   check for convergence 

        taukm1 = tauk

        if (mod(iter,500).eq.0) then
          write(*,*) "Iteration =  ", iter
          write(*,*) "Residual reduction =  ", sqrt(rr/rr0)
        endif 
        
        if(sqrt(rr/rr0).lt.0.0000000000001) goto 6000
        
      enddo
      
 6000 continue
      
c...  communicate solution
      
      do i = 1, NNODZ
        
        if ((IBC(i,1).eq.3).or.(IBC(i,2).eq.3).or.(IBC(i,3).eq.3))
     &    then
          soln(i,:) = soln(IPER(i),:) ! Slave = Master
        endif
        
      enddo
      
      deallocate(lhsKBdiag)
      
      write(*,9000) iter, sqrt(rr / rr0)
      
      return
 9000 format(20x,'  number of iterations:', i10,/,
     &  20x,'    residual reduction:', 2x,e10.2)
      
      end
