c     Modified Jan. 20, 2004

      subroutine StrssProj_3D(col, row)

      use aAdjKeep

      include "common.h"
      

c...  Local variables
      integer iel, igauss, jgauss, kgauss, i, j, k
      integer row(NNODZ*8*(P+1)*(Q+1)*(R+1)), col(NNODZ+1), ni,nj, nk
      real*8 shl(NSHL), shg(NSHL), shgradl(NSHL,NSD),
     &     shgradg(NSHL,NSD)
      real*8 gp(NGAUSS), gw(NGAUSS), gwt, da
      real*8 lambda, numod, Emod, mu, fx, fy, fz, yl(NSHL,NSD)
      real*8 xKebe(NSD*NSD,NSHL,NSHL), Rhs(NSD,NSHL)
        

c...  get Gaussian points and weights
      
      gp = 0d+0
      gw = 0d+0
      
      call genGPandGW(gp,gw)
      
      
      
c...  loop over elements
      do iel = 1, NEL
        
        
c...    Check to see if current element has nonzero area
        ni = INN(IEN(iel,1),1)  ! get NURB coordinates
        nj = INN(IEN(iel,1),2)
        nk = INN(IEN(iel,1),3)
        
        if ((U_KNOT(ni).ne.U_KNOT(ni+1)).and.
     &    (V_KNOT(nj).ne.V_KNOT(nj+1)).and.
     &    (W_KNOT(nk).ne.W_KNOT(nk+1))) then
          
          
          da = (U_KNOT(ni+1) - U_KNOT(ni))*
     &      (V_KNOT(nj+1) - V_KNOT(nj))*
     &      (W_KNOT(nk+1) - W_KNOT(nk))/8d+0 ! used in calculating 
                                ! quadrature points. The factor of 8d+0
                                ! comes from mapping from the [-1,1]
                                ! line onto a real segment...
          
c...      Set up element parameters
          Emod = EY(iel)
          numod = NU(iel)
          
          
          lambda = numod*Emod/((1d+0+numod)*(1d+0-2d+0*numod))
          mu = Emod/(2d+0*(1d+0+numod)) ! PDE
          
          xKebe = 0d+0          ! initialize local stiffness matrix
          Rhs = 0d+0            ! initialize local load vector
          
          
c...      Loop over integration points (NGAUSS in each direction)
          do igauss = 1, NGAUSS
            do jgauss = 1, NGAUSS
              do kgauss = 1, NGAUSS
                
c...            Get Element Shape functions and their gradients
                
                shl = 0d+0      ! initialize
                shg = 0d+0
                shgradl = 0d+0
                shgradg = 0d+0
                
                
                call eval_SHAPE_3D(iel, gp(igauss), gp(jgauss),
     &            gp(kgauss), shl, shgradl,shgradg)
                shg = shl
                
                
c...            Localize solution
                
                do i = 1, NSHL
                  yl(i,:) = yg(IEN(iel,i),:)
                enddo
                
c...            Calculate given element stiffness matrix and force vector
                
                gwt = gw(igauss)*gw(jgauss)*gw(kgauss)*da
                
                call e3LHS_mass_3D(gwt, shg, xKebe)
                
                call e3Rhs_strss_3D(yl, gwt, shg, shgradg,
     &            lambda, mu, Rhs)
                
              enddo
            enddo
          enddo
          
          
c...      assemble into the Sparse Global Stiffness Matrix and Rhs Vector
          
          call FillSparseMat_3D (iel, col, row, xKebe) ! Assemble stiffness
          call LocaltoGlobal_3D (iel, Rhs) ! Assemble load vector
          
        endif
        
      enddo
      
      return
      end
      
