      
      subroutine VizGMV_3D(iproc,numprocs,istep,inistep)
      
      
      use aAdjKeep
      
      include "common.h"
      
      
c...  Local variables
      integer e, igauss, jgauss, i, icount, j, k, kgauss, aa,
     &  NEL_NZA_QUAD, NEL_LIN, NEL_LINm1, icount2, iln, iel, nnodz_lin
      integer ni,nj,nk,strss_file
      integer iproc,numprocs,istep,inistep
      real*8 shl(NSHL), shg(NSHL), shgradl(NSHL,NSD),
     &  shgradg(NSHL, NSD), QuantQuad(8,9), ytemp(NNODZ,NSD)
      real*8 gp(NGAUSS), gw(NGAUSS), skl(2,2,NSD), stl(NSHL,NSD)
      real*8 lambda, numod, Emod, mu, yl(NSHL,NSD), dist, distmin,
     &  summ, std, stdmax
      real*8 dcero
      integer*4 ipoin, idof, ipart 


      character*30 fname
      character*10 cname
      
      integer ifil, lstep
      
      integer, allocatable :: IEN_LIN(:,:)
      real*8, allocatable :: x_lin(:,:), y_lin(:,:), QuantLin(:,:,:)
      
      
c...  get Gaussian points and weights
      NGAUSS = 2
      gp(1) = -1d0
      gp(2) =  1d0
      gw(:) =  0d0
c      NGAUSS = 3
c      gp(1) = -1d+0
c      gp(2) = 0d+0
c      gp(3) = 1d+0
c      gw(:) = 0d+0

      NEL_NZA_QUAD = 0
      NEL_LIN      = 0
      NEL_LINm1    = 0

      NEL_LIN = NEL
      
      stdmax = 0d0

      allocate(QuantLin(NEL,8,9))

      
      do iel = 1, NEL
c...    Check to see if current element has nonzero area
        ni = INN(IEN(iel,1),1)  ! get NURB coordinates
        nj = INN(IEN(iel,1),2)
        nk = INN(IEN(iel,1),3)
        if ((U_KNOT(ni).ne.U_KNOT(ni+1)).and.
     &    (V_KNOT(nj).ne.V_KNOT(nj+1)).and.
     &    (W_KNOT(nk).ne.W_KNOT(nk+1))) then
          icount2 = 0
c...      Loop over integration points (NGAUSS in each direction)
          do igauss = 1, NGAUSS
            do jgauss = 1, NGAUSS
              do kgauss = 1, NGAUSS
                icount2 = icount2+1
c...            Get Element Shape functions and their gradients
                shl = 0d+0      ! initialize
                shg = 0d+0
                shgradl = 0d+0
                shgradg = 0d+0
                call eval_SHAPE_3D(iel, gp(igauss), gp(jgauss),
     &            gp(kgauss), shl, shgradl,shgradg)
                shg = shl                           
                do i = 1,NSHL
                  yl(i, :) = yg(IEN(iel,i),1:NSD)
                enddo
                call eval_QUANT_3D(iel, yl, shg, 
     &            icount2, QuantQuad)
              enddo
            enddo
          enddo
          ! Collect Local Arrays for "linear" elements
          QuantLin(iel,1,:) = QuantQuad(1,:)
          QuantLin(iel,2,:) = QuantQuad(2,:)
          QuantLin(iel,3,:) = QuantQuad(4,:)
          QuantLin(iel,4,:) = QuantQuad(3,:)
          QuantLin(iel,5,:) = QuantQuad(5,:)
          QuantLin(iel,6,:) = QuantQuad(6,:)
          QuantLin(iel,7,:) = QuantQuad(8,:)
          QuantLin(iel,8,:) = QuantQuad(7,:)
        endif
      enddo
      ! Bulid Linear IEN Based on Spatial Location   
      allocate(IEN_LIN(NEL_LIN,8))
      allocate(x_lin(8*NEL_LIN,NSD))
      allocate(y_lin(8*NEL_LIN,6))
      ! Initialize Global Node Count
      icount = 1                
      ! Insert First Global Node
      x_lin(1,:) = QuantLin(1,1,7:9) 
      y_lin(1,:) = QuantLin(1,1,1:6)

      IEN_LIN(1,1) = 1
      distmin = 1d-9
      do iel = 1, NEL_LIN
         do iln = 1, 8                 
            ! Check for repeated nodes
            do k = 1, icount      
               ! Distance to existing Global Nodes
               dist = (x_lin(k,1) - QuantLin(iel,iln,7))**2 +
     &              (x_lin(k,2) - QuantLin(iel,iln,8))**2 +
     &              (x_lin(k,3) - QuantLin(iel,iln,9))**2
               dist = sqrt(dist)
               if (dist.le.distmin) then
                  IEN_LIN(iel,iln) = k ! Repeted Global Node
                  goto 1000
               endif     
            enddo
            ! Add New Global Node
            icount = icount + 1   
            IEN_LIN(iel,iln) = icount
            x_lin(icount,:) = QuantLin(iel,iln,7:9)
            y_lin(icount,:) = QuantLin(iel,iln,1:6)
 1000       continue
         enddo
      enddo

      nnodz_lin = icount
      if (iproc.eq.1) then
        nnodz_glob_lin = 0
        NEL_GLOB_LIN  = 0
        allocate(x_glob_lin(nnodz_lin*2*numprocs,NSD))
        allocate(y_glob_lin(nnodz_lin*2*numprocs,6))
        allocate(IEN_GLOB_LIN(NEL_LIN*2*numprocs,8))
        allocate(glob_mat_dat(NEL_LIN*2*numprocs))
      endif
      ! nnodz_lin - number of global linear nodes for this patch
      ! NEL_LIN - number of linear elements in this patch
      do i = 1, nnodz_lin
         x_glob_lin(nnodz_glob_lin+i,1:NSD) = x_lin(i,1:NSD)
         y_glob_lin(nnodz_glob_lin+i,1:6  ) = y_lin(i,1:6  )
      enddo
      
      do i = 1, NEL_LIN
         glob_mat_dat(NEL_GLOB_LIN+i) = real(iproc) +
     &        1d+2*sin(1.57*real(iproc))
         do j = 1, 8
            IEN_GLOB_LIN(NEL_GLOB_LIN+i,j) = IEN_LIN(i,j) + nnodz_glob_lin
        enddo
      enddo
      
      nnodz_glob_lin = nnodz_glob_lin + nnodz_lin
      NEL_GLOB_LIN = NEL_GLOB_LIN + NEL_LIN
      
      nnodz_lin = 0
      NEL_LIN = 0

      

c...  Write results in the last processor
      if (iproc.eq.numprocs) then
        write(*,*) "Writing solution file"
        nnodz_lin = nnodz_glob_lin
        NEL_LIN = NEL_GLOB_LIN
        dcero = 0d0
        ifil = 99
        if (istep.eq.inistep) then
c          The *.case
           fname = trim ('cornea' // cname(istep)) // '.case'
           OPEN  (ifil,FILE=fname,STATUS='UNKNOWN',FORM='FORMATTED')
           write(ifil,200)
 200       format('#BOF: cornea.case'//
     &            'FORMAT'//
     &            'type: ensight'//
     &            'GEOMETRY'//
     &            'model: cornea.geo'//
     &            'VARIABLE'//
     &            'scalar per node: 1 Concentration cornea.1.res'/
     &            'TIME'//
     &            'time set:                    1'/
     &            'number of steps:             1'/
     &            'filename start number:  000000'/
     &            'filename increment:         10'/
     &            'time values: 1')

           close(ifil)
c          The *.geo file
           fname = trim('cornea' // cname(istep)) // '.geo'
           OPEN  (ifil,FILE=fname,STATUS='UNKNOWN',FORM='FORMATTED')
           write(ifil,'(a)')'CahnHilliard'
           write(ifil,'(a)')'node'
           write(ifil,'(a)')'node id given'
           write(ifil,'(a)')'element id given'
           write(ifil,'(a)')'coordinates'
           write(ifil,'(i8)') nnodz_lin
           !Coordinates
           write(*,*) "Writing coordinates"
           do ipoin = 1, nnodz_lin
              write(ifil,'(i8,3e12.5)') ipoin, 
     &             x_glob_lin(ipoin,1), x_glob_lin(ipoin,2), 
     &             x_glob_lin(ipoin,3)
           enddo
           ipart = 1
           write(ifil,'(a,i8)') 'part', ipart
           write(ifil,'(a)') 'todo'
           write(ifil,'(a)') 'hexa8'
           write(ifil,'(i8)') NEL_LIN
           !Connectivity
           write(*,*) "Writing conectivity"
           do i = 1, NEL_LIN
              write(ifil,'(9i8)') i, (IEN_GLOB_LIN(i,j),j=1,8)
           enddo
           close(ifil)
        endif
c       Solution files
        write(*,*) "Writing solution"
        fname = trim ('cornea' // cname(istep)) // '.res'
        OPEN (ifil,FILE=fname,STATUS='UNKNOWN',FORM='FORMATTED')
        write(ifil,'(a)') 'Concentration'
        write(ifil,'(6e12.5)') y_glob_lin(1:nnodz_lin,4)
        close(ifil)
      endif
      
      deallocate(IEN_LIN)
      deallocate(x_lin)
      deallocate(y_lin)
      deallocate(QuantLin)

      write(*,*)"Finished"
      
      
      return
      end
      

!#########################################################################


      subroutine eval_QUANT_3D(e, yl, shg, 
     &  icount, Quant)
      
      use aAdjKeep
      
      include "common.h"
      
      real*8 yl(NSHL,NSD), shg(NSHL), Quant(NGAUSS**3,9),
     &  xl(NSD), disp(NSD)
      
      integer aa, bb, icount, e
      
      
      xl = 0d+0
      disp = 0d+0
      
c...  Calculate Symmetric Strain Tensor - 3D
      
      do aa = 1, NSHL
        
c...    Displacements and Stresses
        
        disp(1) = disp(1) + yl(aa,1)*shg(aa)
        disp(2) = disp(2) + yl(aa,2)*shg(aa)
        disp(3) = disp(3) + yl(aa,3)*shg(aa)

c...    Locations in reference configuration
        
        xl(1) = xl(1) + 
     &    shg(aa)*B_NET(INN(IEN(e,aa),1), INN(IEN(e,aa),2),
     &    INN(IEN(e,aa),3),1)
        xl(2) = xl(2) +
     &    shg(aa)*B_NET(INN(IEN(e,aa),1), INN(IEN(e,aa),2),
     &    INN(IEN(e,aa),3),2)
        xl(3) = xl(3) +
     &    shg(aa)*B_NET(INN(IEN(e,aa),1), INN(IEN(e,aa),2), 
     &    INN(IEN(e,aa),3),3)
        
      enddo
      
      
c...  Format of the Elmstress is:
c...  for each integration point (indexed by icount) we have 
c...  {S11,S22,S33,S12,S23,S31,dx,dy,dz,x,y,z}
      
      
      Quant(icount,1) = 0d0
      Quant(icount,2) = 0d0
      Quant(icount,3) = 0d0
      
      Quant(icount,4) = disp(1) ! x- displacement
      Quant(icount,5) = disp(2) ! y- displacement
      Quant(icount,6) = disp(3) ! z- displacement
      
      Quant(icount,7) = xl(1)   ! x- coord
      Quant(icount,8) = xl(2)   ! y- coord
      Quant(icount,9) = xl(3)   ! z- coord
      
      return
      end


!#####################################################################

      function cname (i)
      
      logical      beg
      character*10 cname,cc
      integer      il(0:8)

      integer i, ic0, ii, k
      
      ic0 = ICHAR("0")
      cc = " "
      ii = i
      
      il(0) = mod(ii,10)
      do k = 1,8
        ii = (ii - il(k-1)) / 10
        il(k) = mod (ii,10)
      enddo
      
      beg = .false.
      
      do k = 8,1,-1
        if (il(k) .ne. 0 .or. beg) then
          beg = .true.
          cc  = TRIM(cc) // CHAR(ic0 + il(k))
        endif
      enddo
      
      cc = TRIM(cc)//CHAR(ic0 + il(0))
      cname = "." // cc
      
      return
      end
