 

      subroutine profile_scalar(ndiag, icnt)
      
      
      use aAdjKeep
      
      include "common.h"
      
c.... ................................................................
c.... Author : UNKNOWN
c.... ................................................................
c.... This subroutine calculates NDIAG, the vector of indexes 
c.... of diagonal terms
c.... ................................................................
c.... Variable Description:
c.....................................................................
      
c.... Ouptut variables.
      integer ndiag(NNODZ), icnt
      
c.... Local variables.
      integer ne,nnv,i,j,ni,nj,nd1,nd2,nn
      
c.... ................................................................
c.... INITIALIZE
c.... ................................................................
      
      do ni=1, NNODZ
        ndiag(ni) = 1
      enddo
      
c.... ................................................................
c.... Start LOOP over the elements.
c.... ................................................................
      
      nshl = (P+1)*(Q+1)*(R+1)
      
      do ne = 1, NEL
        
        do i = 1, nshl
          ni = IEN(ne,i)
          do j = 1, nshl
            nj = IEN(ne,j)
            ndiag(ni) = max0(ndiag(ni),ni-nj)
          enddo
        enddo
        
      enddo
      
c.... ................................................................
c.... End LOOP over the elements.
c.... ................................................................      
      
      ndiag(1) = 1
      
      do ni=2, NNODZ
        ndiag(ni) = ndiag(ni) + ndiag(ni-1) + 1
      enddo
      
      icnt = ndiag(NNODZ)
      
      return
      end
c.... ................................................................
c.... END-OF-FILE: ../pack_equa/profile.f
c.... ................................................................

      
      subroutine profile_vector(ndiag, icnt)
      
      
      use aAdjKeep
      
      include "common.h"
      
c.... ................................................................
c.... Author : UNKNOWN
c.... ................................................................
c.... This subroutine calculates NDIAG, the vector of indexes 
c.... of diagonal terms
c.... ................................................................
c.... Variable Description:
c.....................................................................
      
c.... Ouptut variables.
      integer ndiag(NSD*NNODZ), icnt
      
c.... Local variables.
      integer ne,nnv,i,j,ni,nj,nd1,nd2,nn, niv1, niv2, niv3
      
c.... ................................................................
c.... INITIALIZE
c.... ................................................................
      
      do ni=1, NNODZ        
        ndiag(3*(ni-1)+1) = 1
        ndiag(3*(ni-1)+2) = 1
        ndiag(3*(ni-1)+3) = 2
      enddo
      
c.... ................................................................
c.... Start LOOP over the elements.
c.... ................................................................
      
      nshl = (P+1)*(Q+1)*(R+1)
      
      do ne = 1, NEL
        
        do i = 1, nshl
          ni = IEN(ne,i)
          niv1 = 3*(ni-1)+1
          niv2 = niv1+1
          niv3 = niv2+1
          do j = 1, nshl
            nj = IEN(ne,j)
            ndiag(niv1) = max0(ndiag(niv1),3*(ni-nj))
            ndiag(niv2) = max0(ndiag(niv2),3*(ni-nj)+1)
            ndiag(niv3) = max0(ndiag(niv3),3*(ni-nj)+2)
          enddo
        enddo
        
      enddo
      
c.... ................................................................
c.... End LOOP over the elements.
c.... ................................................................      
      
      ndiag(1) = 1
      ndiag(2) = 1
      ndiag(3) = 2
      
      do ni=2, 3*NNODZ
        ndiag(ni) = ndiag(ni) + ndiag(ni-1) + 1
      enddo
      
      
      
      icnt = ndiag(3*NNODZ)
      
      return
      end
c.... ................................................................
c.... END-OF-FILE: ../pack_equa/profile.f
c.... ................................................................
      

      
      subroutine profile_vector_iper(ndiag, icnt)
      
      
      use aAdjKeep
      
      include "common.h"
      
c.... ................................................................
c.... Author : UNKNOWN
c.... ................................................................
c.... This subroutine calculates NDIAG, the vector of indexes 
c.... of diagonal terms
c.... ................................................................
c.... Variable Description:
c.....................................................................
      
c.... Ouptut variables.
      integer ndiag(NSD*NNODZ), icnt
      
c.... Local variables.
      integer ne,nnv,i,j,ni,nj,nd1,nd2,nn, niv1, niv2, niv3, nim, njm
      
c.... ................................................................
c.... INITIALIZE
c.... ................................................................
      
      do ni=1, NNODZ        
        ndiag(3*(ni-1)+1) = 1
        ndiag(3*(ni-1)+2) = 1
        if (IPER(ni).eq.ni) then
          ndiag(3*(ni-1)+3) = 2
        else
          ndiag(3*(ni-1)+3) = 1
        endif
      enddo
      
c.... ................................................................
c.... Start LOOP over the elements.
c.... ................................................................
      
      nshl = (P+1)*(Q+1)*(R+1)
      
      do ne = 1, NEL
        
        do i = 1, nshl
          ni = IEN(ne,i)
          nim = IPER(ni)        ! Master
          niv1 = 3*(nim-1)+1
          niv2 = niv1+1
          niv3 = niv2+1
          do j = 1, nshl
            nj = IEN(ne,j)
            njm = IPER(nj)
            ndiag(niv1) = max0(ndiag(niv1),3*(nim-njm))
            ndiag(niv2) = max0(ndiag(niv2),3*(nim-njm)+1)
            ndiag(niv3) = max0(ndiag(niv3),3*(nim-njm)+2)
          enddo
        enddo
        
      enddo
      
c.... ................................................................
c.... End LOOP over the elements.
c.... ................................................................      
      
      ndiag(1) = 1
      ndiag(2) = 1
      
      if(IPER(3).eq.3) then
        ndiag(3) = 2
      else
        ndiag(3) = 1
      endif
      
      do ni=2, 3*NNODZ
        ndiag(ni) = ndiag(ni) + ndiag(ni-1) + 1
      enddo
      
      
      
      icnt = ndiag(3*NNODZ)
      
      return
      end
c.... ................................................................
c.... END-OF-FILE: ../pack_equa/profile.f
c.... ................................................................
